MIB_IFROW Struct
	wszName					DW 				256 Dup(?)	;MAX_INTERFACE_NAME_LEN
	dwIndex					DWord 			?
	dwType					DWord 			?
	dwMtu					DWord 			?
	dwSpeed					DWord 			?
	dwPhysAddrLen			DWord 			?
	bPhysAddr  				DB				8 Dup(?)	;MAXLEN_PHYSADDR
	dwAdminStatus			DWord 			?
	dwOperStatus			DWord 			?
	dwLastChange			DWord 			?
	dwInOctets				DWord 			?
	dwInUcastPkts			DWord 			?
	dwInNUcastPkts			DWord 			?
	dwInDiscards			DWord 			?
	dwInErrors				DWord 			?
	dwInUnknownProtos		DWord 			?
	dwOutOctets				DWord 			?
	dwOutUcastPkts			DWord 			?
	dwOutNUcastPkts			DWord 			?
	dwOutDiscards			DWord 			?
	dwOutErrors				DWord 			?
	dwOutQLen				DWord 			?
	dwDescrLen				DWord 			?
	bDescr					Byte			256 Dup(?)	;MAXLEN_IFDESCR
MIB_IFROW EndS

MIB_IPADDRROW Struct
	dwAddr 					DWord			? ;IP address
	dwIndex					DWord			? ;interface index
	dwMask					DWord			? ;subnet mask
	dwBCastAddr				DWord			? ;broadcast address
	dwReasmSize				DWord			? ;rassembly size
	unused1					Word			? ;not currently used
	unused2					Word			? ;not currently used
MIB_IPADDRROW EndS

ADAPTER_DATA Struct
	dwAddress				DWord			?
	dwIndex					DWord			?
	dwMask					DWord			?
	dwType					DWord			?
	dwBytesIn				DWord			?
	dwBytesOut				DWord			?
	dwLastBytesIn			DWord			?
	dwLastBytesOut			DWord			?
	dwLastSpeedIn			DWord			?
	dwLastSpeedOut			DWord			?
ADAPTER_DATA EndS

.Const

MIB_IF_OPER_STATUS_NON_OPERATIONAL	Equ		0
MIB_IF_OPER_STATUS_UNREACHABLE		Equ 	1
MIB_IF_OPER_STATUS_DISCONNECTED		Equ 	2
MIB_IF_OPER_STATUS_CONNECTING		Equ 	3
MIB_IF_OPER_STATUS_CONNECTED		Equ 	4
MIB_IF_OPER_STATUS_OPERATIONAL		Equ 	5

MIB_IF_TYPE_OTHER					Equ		1
MIB_IF_TYPE_ETHERNET				Equ		6
MIB_IF_TYPE_TOKENRING				Equ		9
MIB_IF_TYPE_FDDI					Equ		15
MIB_IF_TYPE_PPP						Equ		23
MIB_IF_TYPE_LOOPBACK				Equ		24
MIB_IF_TYPE_SLIP					Equ		28

TCP_TABLE_BASIC_LISTENER			Equ		0
TCP_TABLE_BASIC_CONNECTIONS			Equ		1
TCP_TABLE_BASIC_ALL					Equ		2
TCP_TABLE_OWNER_PID_LISTENER		Equ		3
TCP_TABLE_OWNER_PID_CONNECTIONS		Equ		4
TCP_TABLE_OWNER_PID_ALL				Equ		5
TCP_TABLE_OWNER_MODULE_LISTENER		Equ		6
TCP_TABLE_OWNER_MODULE_CONNECTIONS	Equ		7
TCP_TABLE_OWNER_MODULE_ALL			Equ		8

UDP_TABLE_BASIC						Equ		0
UDP_TABLE_OWNER_PID					Equ		1
UDP_TABLE_OWNER_MODULE				Equ		2

STATUS_DISCONN 						Equ		(-1)
STATUS_NONE							Equ		0
STATUS_RECEIVE 						Equ		1
STATUS_SEND							Equ		2

MC_RESIZE							Equ		9999

WM_TRAYMESSAGE						Equ		(WM_USER + 2048)


.Data?

dwIfTableIndex				DWord			64 Dup(?)

rcLarge						RECT			<?>
rcSmall						RECT			<?>


.Data

szLeft						Byte			'Left', 0
szTop						Byte			'Top', 0
dwCurrentIndex				DWord			(-1)
dwNumConns					DWord			0
dwNetState					DWord			STATUS_NONE
dwPtrSize					DWord			64
dwCounter1					DWord			0
dwCounter2					DWord			0
dwCounter3					DWord			0
dwCountDown					DWord			(-1)
WM_TASKBARCREATED			DWord			(-1)
bCountDownActive			BOOL			FALSE
bFirst						BOOL			TRUE
bDoThread					BOOL			TRUE
bLocalTcpDescending			BOOL			TRUE
bLocalUdpDescending			BOOL			TRUE
bModalWindowOn				BOOL			FALSE
bRealIPAddress				BOOL			FALSE
bRefreshingTcp				BOOL			FALSE
bRefreshingUdp				BOOL			FALSE
bRemoteTcpDescending		BOOL			FALSE
bRemoteUdpDescending		BOOL			FALSE
bScrolling					BOOL			FALSE
bShowIcon					BOOL			FALSE
bSmallSize					BOOL			FALSE
bStateTcpDescending			BOOL			TRUE
bStateUdpDescending			BOOL			TRUE
bThreadActive				BOOL			FALSE
bTcpPortsTab				BOOL			FALSE
bUdpPortsTab				BOOL			FALSE
lCurrentTdpSort				LONG			1
lCurrentUdpSort				LONG			1
lLeft						LONG			0
lLargeTop					LONG			0
lSmallTop					LONG			0
lTimer						LONG			0
hWndCombo					HWND			NULL
hWndLvTcp					HWND			NULL
hWndLvUdp					HWND			NULL
lpPtr						LPVOID			NULL
hIpHlpApi					HINSTANCE		NULL
hMainMenu					HMENU			NULL
hMainSubMenu				HMENU			NULL
hTcpMenu					HMENU			NULL
hTcpSubMenu					HMENU			NULL
hUdpMenu					HMENU			NULL
hUdpSubMenu					HMENU			NULL
hIconDisconn				HICON			NULL
hCursorHand					HCURSOR			NULL
hMutex						HANDLE			NULL

dwRS_ONE_KB					DWord	1024
dwRS_ONE_KB_DIV_10			DWord	102
dwRS_ONE_MB					DWord	1048576 ;(1024 * 1024)
dwRS_ONE_MB_DIV_10			DWord	104857

SpeedScale    				DWord			0

MibIfRow					MIB_IFROW		<{0}>


include ECProtos.inc ; .Code

NetMonProcedure Proc Private hWnd:HWND, uMsg:ULONG, wParam:WPARAM, lParam:LPARAM
	Local rc:RECT, pt:POINTL

	Mov Eax, WM_TASKBARCREATED
	.If Eax == uMsg
		Invoke Shell_NotifyIcon, NIM_ADD, Addr IconData
	.ElseIf uMsg == WM_CREATE
		Invoke GlobalAlloc, GPTR, MAX_PATH
		Mov Esi, Eax
		Invoke CreateWindowEx, 0, TextStr("LISTBOX"), NULL, WS_CHILD, -10, -10, 0, 0, App.Main, 0, App.Instance, NULL
		Mov hWndLBStr, Eax
		Invoke GetAppStrings, IDR_LANGUAGE_FILE
		Invoke SetText, hWnd, App.Header

		Invoke LoadAndSetText, hWnd, Esi, IDS_ADAPTER, IDC_NETMON_GROUP1
		Invoke LoadAndSetText, hWnd, Esi, IDS_SECOND_TRASNFER_SPEED, IDC_NETMON_GROUP3
		Invoke LoadAndSetText, hWnd, Esi, IDS_SPEED, IDC_NETMON_STATIC1
		Invoke LoadAndSetText, hWnd, Esi, IDS_SUBMASK, IDC_NETMON_STATIC2
		Invoke LoadAndSetText, hWnd, Esi, IDS_RECEIVED, IDC_NETMON_STATIC3
		Invoke LoadAndSetText, hWnd, Esi, IDS_SENT, IDC_NETMON_STATIC4
		Invoke LoadAndSetText, hWnd, Esi, IDS_IP_ADDRESS, IDC_NETMON_STCLBLIP
		Invoke LoadAndSetText, hWnd, Esi, IDS_REAL_ADDRESS, IDC_NETMON_STCLBLREALIP
		Invoke LoadAndSetText, hWnd, Esi, IDS_CONNECTING, IDC_NETMON_STCREALIP
		Invoke LoadAndSetText, hWnd, Esi, IDS_KBYTES, IDC_NETMON_STCSPEEDOUT
		Invoke LoadAndSetText, hWnd, Esi, IDS_KBYTES, IDC_NETMON_STCSPEEDIN

		Invoke GlobalFree, Esi
		Xor Edi, Edi
		Invoke CreateMutex, NULL, TRUE, TextStr("RSNetMon")
		Mov hMutex, Eax
		Invoke GetLastError
		Cmp Eax, ERROR_ALREADY_EXISTS
		Jne @F
		Mov Edi, (-1)
@@:		.If App.Previous != NULL
			Invoke IsWindowVisible, App.Previous
			Or Eax, Eax
			Jnz @F
			Invoke SendMessage, App.Previous, WM_COMMAND, IDM_MENU_MONITOR, NULL
@@:			Invoke SetActiveWindow, App.Previous
			Invoke SetForegroundWindow, App.Previous
@@:			Invoke SendMessage, hWndLBStr, LB_RESETCONTENT, 0, 0
			Invoke DestroyWindow, hWndLBStr
			Return(-1)
		.EndIf
		Cmp Edi, (-1)
		Je @B
		Invoke GetPlatform, NULL
		Mov lPlatForm, Eax
		.If Eax < ecWin98
			Invoke LoadAppString, IDS_NO_WIN98, Addr szBuffer, MAX_PATH
			Invoke MessageBox, hWnd, Addr szBuffer, App.Header, MB_OK
			Jmp @B
		.EndIf
@@:		Invoke LoadLibrary, TextStr("IPHLPAPI.dll")
		Mov hIpHlpApi, Eax
		Or Eax, Eax
		Jz @F
		Invoke GetProcAddress, hIpHlpApi, TextStr("GetExtendedTcpTable")
		Mov lpGetExtendedTcpTable, Eax
		Invoke GetProcAddress, hIpHlpApi, TextStr("GetExtendedUdpTable")
		Mov lpGetExtendedUdpTable, Eax
@@:		Lea Ebx, dwIfTableIndex
		Xor Eax, Eax
		Mov Ecx, 64
@@:		Mov [Ebx], Eax
		Add Ebx, 4
		Loop @B

		Invoke GetSystemMenu, hWnd, FALSE
		Mov Edi, Eax
		Invoke DeleteMenu, Edi, SC_RESTORE, MF_BYCOMMAND
		Invoke DeleteMenu, Edi, SC_SIZE, MF_BYCOMMAND
		Invoke DeleteMenu, Edi, SC_MAXIMIZE, MF_BYCOMMAND
		Invoke DeleteMenu, Edi, SC_MINIMIZE, MF_BYCOMMAND
		Lea Esi, szBuffer
		Invoke LoadAppString, IDS_RESIZE, Esi, 64
		Add Esi, 128
		Mov [Esi].MENUITEMINFO.cbSize, SizeOf MENUITEMINFO
		Mov [Esi].MENUITEMINFO.fType, MFT_STRING
		Mov [Esi].MENUITEMINFO.fMask, (MIIM_TYPE Or MIIM_ID Or MIIM_STATE)
		Mov [Esi].MENUITEMINFO.wID, MC_RESIZE
		Mov [Esi].MENUITEMINFO.fState, MFS_ENABLED
		Mov [Esi].MENUITEMINFO.dwTypeData, Offset szBuffer
		Invoke InsertMenuItem, Edi, 1, TRUE, Esi

		Mov Eax, hWnd
		Mov IconData.hwnd, Eax
		Mov IconData.cbSize, SizeOf NOTIFYICONDATA
		Mov IconData.uFlags, (NIF_ICON Or NIF_MESSAGE Or NIF_TIP)
		Mov IconData.uCallbackMessage, WM_TRAYMESSAGE
		Invoke lstrcpy, Addr IconData.szTip, App.Header
		Invoke GlobalAlloc, GPTR, dwPtrSize
		Mov lpPtr, Eax
		Invoke GetWindowItem, hWnd, IDC_NETMON_COMBO1
		Mov hWndCombo, Eax
		Invoke GetWindowItem, hWnd, IDC_NETMON_IMAGE1
		Mov hWndImage, Eax
		Invoke GetWindowItem, hWnd, IDC_NETMON_IMGDOWN
		Mov hWndImgDown, Eax
		Invoke GetWindowItem, hWnd, IDC_NETMON_IMGUP
		Mov hWndImgUp, Eax
		Invoke GetWindowLong, Eax, GWL_STYLE
		And Eax, 0FFFFFFF0H
		Or Eax, SS_ICON
		Mov Edi, Eax
		Invoke SetWindowLong, hWndImage, GWL_STYLE, Eax
		Invoke SetWindowLong, hWndImgDown, GWL_STYLE, Edi
		Invoke SetWindowLong, hWndImgUp, GWL_STYLE, Edi
		Invoke GetMeterRegistrySettings
		Invoke GetWindowItem, hWnd, IDC_NETMON_GROUP3
		Mov Edi, Eax
		Invoke CreateMeter, Edi, 8, 20, RSMETER_INSET
		Mov lMeterDownIndex, Eax
		Invoke SetMeterMaxValue, Eax, lMeterDownMaxValue
		Invoke SetMeterWidth, lMeterDownIndex, 4
		Invoke SetMeterHeight, lMeterDownIndex, 13
		Invoke CreateMeter, Edi, 8, 37, RSMETER_INSET
		Mov lMeterUpIndex, Eax
		Invoke SetMeterMaxValue, Eax, lMeterUpMaxValue
		Invoke SetMeterWidth, lMeterUpIndex, 4
		Invoke SetMeterHeight, lMeterUpIndex, 13

		Invoke GetWindowItem, hWnd, IDC_NETMON_LISTVIEW1
		Mov hWndLvTcp, Eax
		Invoke GetWindowItem, hWnd, IDC_NETMON_LISTVIEW2
		Mov hWndLvUdp, Eax
		
		Invoke GetClientRect, hWndLvTcp, Addr rc
		Invoke GetSystemMetrics, SM_CXVSCROLL
		Sub rc.right, Eax
		Xor Edx, Edx
		Mov Eax, 3
		Xchg Eax, rc.right
		Push Eax
		Div rc.right
		Sub Eax, 10
		Mov rc.right, Eax

		Mov Ebx, 32
		Mov Ecx, rc.right
		Shl Ecx, 1
		Add Ecx, rc.right
		Add Ecx, Ebx
		Pop Eax
		Cmp Ecx, Eax
		Jle @F
		Sub Ecx, Eax
		Sub Ebx, Ecx
@@:		Mov Word Ptr szBuffer[0], 0
		Invoke AddListViewColumn, hWndLvTcp, Addr szBuffer, (-1), 0, LVCFMT_LEFT

		Mov Word Ptr szBuffer[0], 0
		Invoke AddListViewColumn, hWndLvUdp, Addr szBuffer, (-1), 0, LVCFMT_LEFT
		
		Invoke LoadAppString, IDS_LOCAL, Addr szBuffer, 64
		Invoke AddListViewColumn, hWndLvTcp, Addr szBuffer, rc.right, 1, LVCFMT_CENTER

		Invoke LoadAppString, IDS_PORT, Addr szBuffer, 64
		Mov Eax, rc.right
		Sub Eax, 20
		Invoke AddListViewColumn, hWndLvUdp, Addr szBuffer, Eax, 1, LVCFMT_CENTER

		Invoke LoadAppString, IDS_REMOTE, Addr szBuffer, 64
		Invoke AddListViewColumn, hWndLvTcp, Addr szBuffer, rc.right, 2, LVCFMT_CENTER

		Invoke LoadAppString, IDS_LOCAL_ADDRESS, Addr szBuffer, 64
		Add Eax, Offset szBuffer
		Dec Eax
		Mov Byte Ptr [Eax], 0
		Mov Eax, rc.right
		Add Eax, 20
		Invoke AddListViewColumn, hWndLvUdp, Addr szBuffer, Eax, 2, LVCFMT_CENTER
		
		Add rc.right, Ebx

		Invoke LoadAppString, IDS_STATE, Addr szBuffer, 64
		Invoke AddListViewColumn, hWndLvTcp, Addr szBuffer, rc.right, 3, LVCFMT_CENTER

		Invoke LoadAppString, IDS_PROCESS, Addr szBuffer, 64
		Add Eax, Offset szBuffer
		Dec Eax
		Mov Byte Ptr [Eax], 0
		Invoke AddListViewColumn, hWndLvUdp, Addr szBuffer, rc.right, 3, LVCFMT_CENTER

		.If lPlatForm > ecWin98
			Invoke GetRegistryValueA, HKEY_CURRENT_USER, TextStr("Control Panel\International"), TextStr("sDecimal"), Addr szBuffer
			.If Eax
				Mov Al, [szBuffer]
				Mov [sDecimal], Al
			.EndIf
			Invoke GetRegistryValueA, HKEY_CURRENT_USER, TextStr("Control Panel\International"), TextStr("sThousand"), Addr szBuffer
			.If Eax
				Mov Al, [szBuffer]
				Mov [sThousand], Al
			.EndIf
		.Else
			Invoke GetProfileString, TextStr("intl"), TextStr("sDecimal"), Addr sDecimal, Addr szBuffer, 63
			.If Eax
				Mov Al, [szBuffer]
				Mov [sDecimal], Al
			.EndIf
			Invoke GetProfileString, TextStr("intl"), TextStr("sThousand"), Addr sThousand, Addr szBuffer, 63
			.If Eax
				Mov Al, [szBuffer]
				Mov [sThousand], Al
			.EndIf
		.EndIf
		Invoke LoadMenu, App.Instance, IDR_MAIN_MENU
		Mov hMainMenu, Eax
		Invoke GetSubMenu, Eax, 0
		Mov hMainSubMenu, Eax
		Invoke LoadMenu, App.Instance, IDR_TCP_MENU
		Mov hTcpMenu, Eax
		Invoke GetSubMenu, Eax, 0
		Mov hTcpSubMenu, Eax
		Invoke LoadMenu, App.Instance, IDR_UDP_MENU
		Mov hUdpMenu, Eax
		Invoke GetSubMenu, Eax, 0
		Mov hUdpSubMenu, Eax

		;Set tabs text
		Invoke GetWindowItem, hWnd, IDC_NETMON_TABSTRIP1
		Mov Edi, Eax
		Invoke SetTabItemText, Edi, 0, IDS_ACTIVITY
		Invoke SetTabItemText, Edi, 1, IDS_TCP_PORTS
		Invoke SetTabItemText, Edi, 2, IDS_UDP_PORTS

		;Main menu
		Invoke SetMenuText, hMainSubMenu, IDM_MENU_MONITOR, IDS_SHOW_MONITOR, FALSE
		Invoke SetMenuText, hMainSubMenu, IDM_MENU_ONTOP, IDS_ALWAYS_ON_TOP, FALSE
		Invoke SetMenuText, hMainSubMenu, IDM_MENU_SETTINGS, IDS_SETTINGS, FALSE
		Invoke SetMenuText, hMainSubMenu, 6, IDS_PRIORITY, TRUE
		Invoke SetMenuText, hMainSubMenu, IDM_MENU_HIGH, IDS_HIGH, FALSE
		Invoke SetMenuText, hMainSubMenu, IDM_MENU_NORMAL, IDS_NORMAL, FALSE
		Invoke SetMenuText, hMainSubMenu, IDM_MENU_LOW, IDS_LOW, FALSE
		Invoke SetMenuText, hMainSubMenu, IDM_MENU_AFFINITY, IDS_AFFINITY, FALSE
		Invoke SetMenuText, hMainSubMenu, 9, IDS_COUNTDOWN, TRUE
		Invoke SetMenuText, hMainSubMenu, IDM_MENU_ACTIVATE, IDS_ACTIVATE, FALSE
		Invoke SetMenuText, hMainSubMenu, IDM_MENU_COUNT_SETTINGS, IDS_SETTINGS, FALSE
		Invoke SetMenuText, hMainSubMenu, IDM_MENU_ABOUT, IDS_ABOUT, FALSE
		Invoke SetMenuText, hMainSubMenu, IDM_MENU_NETWORK, IDS_NETWORK_CONNECTIONS, FALSE
		Invoke SetMenuText, hMainSubMenu, IDM_MENU_EXIT, IDS_EXIT, FALSE

		;TCP menu
		Invoke SetMenuText, hTcpMenu, IDM_MENU_CLOSE_PORT, IDS_CLOSE_PORT, FALSE
		Invoke SetMenuText, hTcpMenu, IDM_MENU_TERMINATE_PROCESS, IDS_TERMINATE_PROCESS, FALSE
		Invoke SetMenuText, hTcpMenu, IDM_MENU_DETAILS, IDS_DETAILS, FALSE
		Invoke SetMenuText, hTcpMenu, IDM_MENU_REFRESH, IDS_REFRESH, FALSE

		;UDP menu
		Invoke SetMenuText, hUdpMenu, IDM_MENU_TERMINATE_PROCESS_UDP, IDS_TERMINATE_PROCESS, FALSE
		Invoke SetMenuText, hUdpMenu, IDM_MENU_REFRESH_UDP, IDS_REFRESH, FALSE

		Cmp lpGetExtendedTcpTable, 0
		Jne @F
		Invoke DeleteMenu, hTcpSubMenu, IDM_MENU_TERMINATE_PROCESS, MF_BYCOMMAND
@@:		Cmp lpGetExtendedUdpTable, 0
		Jne @F
		Invoke DeleteMenu, hUdpSubMenu, 1, MF_BYPOSITION
		Invoke DeleteMenu, hUdpSubMenu, IDM_MENU_TERMINATE_PROCESS_UDP, MF_BYCOMMAND
@@:		Invoke LoadImage, App.Instance, IDI_ICON_BOTH, IMAGE_ICON, 32, 32, LR_LOADMAP3DCOLORS
		Mov hIconBoth, Eax
		Invoke LoadImage, App.Instance, IDI_ICON_NO_NET, IMAGE_ICON, 32, 32, LR_LOADMAP3DCOLORS
		Mov hIconDisconn, Eax
		Invoke LoadImage, App.Instance, IDI_ICON_DOWN_OFF, IMAGE_ICON, 16, 16, LR_LOADMAP3DCOLORS
		Mov hIconDownOff, Eax
		Invoke SendMessage, hWndImgDown, STM_SETICON, Eax, 0
		Invoke LoadImage, App.Instance, IDI_ICON_DOWN_ON, IMAGE_ICON, 16, 16, LR_LOADMAP3DCOLORS
		Mov hIconDownOn, Eax
		Invoke LoadImage, App.Instance, IDI_ICON_NONE, IMAGE_ICON, 32, 32, LR_LOADMAP3DCOLORS
		Mov hIconNone, Eax
		Mov IconData.hIcon, Eax
		Invoke SendMessage, hWndImage, STM_SETICON, Eax, 0
		Invoke LoadImage, App.Instance, IDI_ICON_RECEIVE, IMAGE_ICON, 32, 32, LR_LOADMAP3DCOLORS
		Mov hIconReceive, Eax
		Invoke LoadImage, App.Instance, IDI_ICON_SEND, IMAGE_ICON, 32, 32, LR_LOADMAP3DCOLORS
		Mov hIconSend, Eax
		Invoke LoadImage, App.Instance, IDI_ICON_UP_OFF, IMAGE_ICON, 16, 16, LR_LOADMAP3DCOLORS
		Mov hIconUpOff, Eax
		Invoke SendMessage, hWndImgUp, STM_SETICON, Eax, 0
		Invoke LoadImage, App.Instance, IDI_ICON_UP_ON, IMAGE_ICON, 16, 16, LR_LOADMAP3DCOLORS
		Mov hIconUpOn, Eax
		Invoke LoadImage, App.Instance, IDC_CURSOR_HAND, IMAGE_CURSOR, 32, 32, LR_LOADMAP3DCOLORS
		Mov hCursorHand, Eax
		Invoke SetMeterDownNewColor, 00FFFF00H
		Invoke SetMeterUpNewColor, 0000FFFFH

		Invoke GetWindowRect, hWnd, Addr rc
		Mov Eax, rc.right
		Sub Eax, rc.left
		Mov rc.right, Eax
		Mov Eax, rc.bottom
		Sub Eax, rc.top
		Mov rc.bottom, Eax
		Invoke GetRegistryValueA, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szLeft, Addr szBuffer
		.If Eax
			Invoke ValueA, Addr szBuffer
			Mov rc.left, Eax
		.EndIf
		Invoke GetRegistryValueA, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szTop, Addr szBuffer
		.If Eax
			Invoke ValueA, Addr szBuffer
			Mov rc.top, Eax
		.EndIf
		Invoke CopyRect, Addr rcLarge, Addr rc
		Invoke CopyRect, Addr rcSmall, Addr rc
		Invoke GetRegistryValueA, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szSmallLeft, Addr szBuffer
		.If Eax
			Invoke ValueA, Addr szBuffer
			Mov rcSmall.left, Eax
		.EndIf
		Invoke GetRegistryValueA, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szSmallTop, Addr szBuffer
		.If Eax
			Invoke ValueA, Addr szBuffer
			Mov rcSmall.top, Eax
		.EndIf
		Invoke GetRegistryValueA, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szAutoRefreshPorts, Addr szBuffer
		.If Eax
			Invoke ValueA, Addr szBuffer
			.If Eax < DWord Ptr 0 || Eax > DWord Ptr 9
				Xor Eax, Eax
			.EndIf
			Mov lAutoRefreshPorts, Eax
		.EndIf
		Invoke GetWindowLong, hWnd, GWL_EXSTYLE
		And Eax, (Not WS_EX_APPWINDOW)
		Invoke SetWindowLong, hWnd, GWL_EXSTYLE, Eax
		Invoke SetWindowPos, hWnd, Edi, 0, 0, 0, 0, (SWP_NOMOVE Or SWP_NOSIZE Or SWP_FRAMECHANGED Or SWP_HIDEWINDOW)
		Invoke GetWindowItem, hWnd, IDC_NETMON_GROUP3
		Mov Edx, Eax
		Invoke GetWindowRect, Edx, Addr rc
		Invoke ScreenToClient, hWnd, Addr rc
		Push rc.left
		Invoke GetWindowItem, hWnd, IDC_NETMON_TABSTRIP1 ;GROUP1
		Mov Edx, Eax
		Invoke GetWindowRect, Edx, Addr rc
		Invoke ScreenToClient, hWnd, Addr rc
		Pop lLeft
		Mov Eax, rc.top
		Add Eax, 2
		Mov lSmallTop, Eax
		Push Eax
		Invoke GetWindowItem, hWnd, IDC_NETMON_GROUP3
		Mov Edx, Eax
		Invoke GetWindowRect, Edx, Addr rc
		Invoke ScreenToClient, hWnd, Addr rc
		Mov Edi, rc.top
		Mov lLargeTop, Edi
		Pop Eax
		Sub Edi, Eax
		Sub rcSmall.bottom, Edi
		Invoke GetRegistryValueA, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szSmallSize, Addr szBuffer
		.If Eax
			Invoke ValueA, Addr szBuffer
			Mov bSmallSize, Eax
		.EndIf
		Invoke SetMonitorSize, hWnd
		Invoke RefreshTcpOpenPorts, hWnd
		Invoke RefreshUdpOpenPorts, hWnd
		Invoke GetWindowItem, hWnd, IDC_NETMON_GRPLISTVIEW
		Invoke ShowWindow, Eax, SW_HIDE
		Invoke InitInterfaces
		Cmp Eax, NO_ERROR
		Je @F
L2:		Invoke SendMessage, hWnd, WM_DESTROY, 0, 0
		Mov Eax, (-1)
		Ret
@@:		Invoke GetWindowItem, hWnd, IDC_NETMON_THREAD
		Push Eax
		Invoke ResumeThread, Eax
		Invoke GetCurrentProcess
		Mov Edi, Eax
		Invoke GetProcessAffinityMask, Edi, Addr rc.left, Addr rc.right
		Invoke GetSubMenu, hMainMenu, 0
		.If rc.left == 1
			Invoke DeleteMenu, Eax, 7, MF_BYPOSITION
		.Else
			Invoke String, rc.left, Addr szBuffer, ecDecimal
			Invoke GetRegistryValueA, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szAffinity, Addr szBuffer
			Invoke ValueA, Addr szBuffer
			.If Eax
				Invoke SetAffinityMask, Edi, Eax
			.EndIf
		.EndIf
		Pop Eax
		Or Eax, Eax
		Jz L2
		Invoke GetRegistryValueA, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szVisible, Addr szBuffer
		.If Eax
			Invoke ValueA, Addr szBuffer
			.If Eax
				Invoke SendMessage, hWnd, WM_COMMAND, IDM_MENU_MONITOR, NULL
			.EndIf
		.EndIf
		Invoke StringA, MFS_CHECKED, Addr szBuffer, ecDecimal
		Invoke GetRegistryValueA, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szOnTop, Addr szBuffer
		Invoke ValueA, Addr szBuffer
		Test Eax, MFS_CHECKED
		.If !Zero?
			Invoke SendMessage, hWnd, WM_COMMAND, IDM_MENU_ONTOP, 0
		.EndIf

		Invoke StringA, BELOW_NORMAL_PRIORITY_CLASS, Addr szBuffer, ecDecimal
		Invoke GetRegistryValueA, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szPriority, Addr szBuffer
		Invoke Value, Addr szBuffer
		Mov Ecx, IDM_MENU_NORMAL
		Cmp Eax, NORMAL_PRIORITY_CLASS
		Je @F
		Mov Ecx, IDM_MENU_HIGH
		Cmp Eax, ABOVE_NORMAL_PRIORITY_CLASS
		Je @F
		Mov Ecx, IDM_MENU_LOW
@@:		Invoke SendMessage, hWnd, WM_COMMAND, Ecx, 0

		Lea Esi, szBuffer
		Mov Word Ptr [Esi], '1'
		Invoke GetRegistryValueA, HKEY_CURRENT_USER, Addr szRegistryKey, Addr sz10Percent, Esi
		Invoke Value, Esi
		Mov b10Percent, Eax

		Invoke lstrcpy, Esi, TextStr("60")
		Invoke GetRegistryValueA, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szCountSeconds, Esi
		Invoke Value, Esi
		Mov lCountSeconds, Eax

		Invoke GetWindowItem, hWnd, IDC_NETMON_TABSTRIP1
		Invoke SetFocus, Eax
		Return TRUE
	.ElseIf uMsg == WM_COMMAND
		HiWord wParam
		.If Ax == 0 && lParam == NULL
			Mov Eax, wParam
			.If Ax == IDM_MENU_MONITOR
				Invoke IsWindowVisible, hWnd
				Or Eax, Eax
				Jz @F
				Invoke SendMessage, hWnd, WM_CLOSE, 0, 0
				Ret
@@:				Invoke ShowWindow, hWnd, SW_SHOWNORMAL
				Invoke UpdateWindow, hWnd
				Invoke SetActiveWindow, hWnd
				Invoke SetForegroundWindow, hWnd
				Invoke CheckMenu, IDM_MENU_MONITOR
				Invoke wsprintf, Addr szBuffer, Addr szFormat, BST_CHECKED
				Invoke SetRegistryValueA, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szVisible, Addr szBuffer
				Return TRUE
			.ElseIf Ax == IDM_MENU_ABOUT
				Invoke CheckMainWindow, hWnd
@@:				Mov bModalWindowOn, TRUE
				Invoke Create, TextStr("About"), hWnd, ecModal, NULL
				Mov bModalWindowOn, FALSE
				Return TRUE
			.ElseIf Ax == IDM_MENU_ONTOP
				Invoke CheckMenu, IDM_MENU_ONTOP
				.If Eax == MFS_CHECKED
					Mov Edi, Eax
					Mov Eax, HWND_TOPMOST
				.Else
					Mov Edi, MFS_UNCHECKED
					Mov Eax, HWND_NOTOPMOST
				.EndIf
				Invoke SetWindowPos, hWnd, Eax, 0, 0, 0, 0, (SWP_NOMOVE Or SWP_NOSIZE Or SWP_FRAMECHANGED)
				Invoke wsprintf, Addr szBuffer, Addr szFormat, Edi
				Invoke SetRegistryValueA, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szOnTop, Addr szBuffer
				Return TRUE
			.ElseIf Ax == IDM_MENU_SETTINGS
				Invoke CheckMainWindow, hWnd
				Mov bModalWindowOn, TRUE
				Invoke Create, TextStr("Settings"), hWnd, ecModal, NULL
				Mov bModalWindowOn, FALSE
				Return TRUE
			.ElseIf Ax == IDM_MENU_NETWORK
				Invoke OpenNetworkConnections, hWnd
				Return TRUE
			.ElseIf Ax == IDM_MENU_LOW || Ax == IDM_MENU_NORMAL || Ax == IDM_MENU_HIGH
				Push Eax
				Invoke CheckMenuItem, hMainSubMenu, IDM_MENU_LOW, (MF_BYCOMMAND Or MF_UNCHECKED)
				Invoke CheckMenuItem, hMainSubMenu, IDM_MENU_NORMAL, (MF_BYCOMMAND Or MF_UNCHECKED)
				Invoke CheckMenuItem, hMainSubMenu, IDM_MENU_HIGH, (MF_BYCOMMAND Or MF_UNCHECKED)
				Pop Eax
				.If Ax == IDM_MENU_NORMAL
					Mov Edi, NORMAL_PRIORITY_CLASS
				.ElseIf Ax == IDM_MENU_HIGH
					Mov Edi, ABOVE_NORMAL_PRIORITY_CLASS
					.If lPlatForm < ecWin2K
						Mov Edi, HIGH_PRIORITY_CLASS
					.EndIf
				.Else ; IDM_MENU_LOW
					Mov Edi, BELOW_NORMAL_PRIORITY_CLASS
					.If lPlatForm < ecWin2K
						Mov Edi, IDLE_PRIORITY_CLASS
					.EndIf
				.EndIf
				Invoke CheckMenu, Eax
				Invoke GetCurrentProcess
				Invoke SetPriorityClass, Eax, Edi
				Invoke String, Edi, Addr szBuffer, ecDecimal
				Invoke SetRegistryValueA, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szPriority, Addr szBuffer
				Return TRUE
			.ElseIf Ax == IDM_MENU_AFFINITY
				Invoke CheckMainWindow, hWnd
				Mov bModalWindowOn, TRUE
				Invoke Create, TextStr("Affinity"), hWnd, ecModal, NULL
				Mov bModalWindowOn, FALSE
				Return TRUE
			.ElseIf Ax == IDM_MENU_ACTIVATE
				.If bCountDownActive
					Mov Edx, IDS_ACTIVATE
					Xor Eax, Eax
				.Else
					Mov Edx, IDS_DEACTIVATE
					Mov Eax, TRUE
				.EndIf
				Mov bCountDownActive, Eax
				Lea Esi, szBuffer
				Invoke LoadAppString, Edx, Esi, 64
				Add Esi, 128
				Mov [Esi].MENUITEMINFO.cbSize, SizeOf MENUITEMINFO
				Mov [Esi].MENUITEMINFO.fType, MFT_STRING
				Mov [Esi].MENUITEMINFO.fMask, MIIM_TYPE
				Mov [Esi].MENUITEMINFO.dwTypeData, Offset szBuffer
				Invoke GetSubMenu, hMainMenu, 0
				Invoke SetMenuItemInfo, Eax, IDM_MENU_ACTIVATE, FALSE, Esi
				Invoke ActivateCountDown
				Return TRUE
			.ElseIf Ax == IDM_MENU_COUNT_SETTINGS
				Invoke CheckMainWindow, hWnd
				Mov bModalWindowOn, TRUE
				Invoke Create, TextStr("CountDown"), hWnd, ecModal, 0
				Mov bModalWindowOn, FALSE
				.If bCountDownActive
					Invoke ActivateCountDown
				.EndIf
				Return TRUE
			.ElseIf Ax == IDM_MENU_EXIT
				Invoke CloseMonitorWindow, hWnd, TRUE
				Invoke SendMessage, hWnd, WM_DESTROY, 0, 0
				Ret
			.Else
				.If Ax == IDM_MENU_REFRESH
					Invoke RefreshTcpOpenPorts, hWnd
					Return TRUE
				.ElseIf Ax == IDM_MENU_REFRESH_UDP
					Invoke RefreshUdpOpenPorts, hWnd
					Return TRUE
				.ElseIf Ax == IDM_MENU_TERMINATE_PROCESS_UDP
					Invoke SetWaitCursor, hWnd
					Invoke GetUdpEntry, Addr szBuffer
					.If Eax
						Invoke GetCurrentProcess
						Mov Esi, Eax
						Invoke SetPrivileges, Esi, TRUE
						Xor Ebx, Ebx
						Lea Edi, szBuffer
						Mov Eax, [Edi].MIB_UDPROW_OWNER_PID.dwOwningPid
						Invoke OpenProcess, PROCESS_TERMINATE, FALSE, [Edi].MIB_UDPROW_OWNER_PID.dwOwningPid
						.If Eax
							Mov Ebx, Eax
							Invoke TerminateProcess, Ebx, 0
						.EndIf
						.If Ebx
							Invoke CloseHandle, Ebx
							Invoke Sleep, 500
							Invoke RefreshUdpOpenPorts, hWnd
						.EndIf
						Invoke SetPrivileges, Esi, FALSE
					.EndIf
					Invoke SetDefaultCursor
				.Else
					.If Ax == IDM_MENU_CLOSE_PORT || Ax == IDM_MENU_TERMINATE_PROCESS || Ax == IDM_MENU_DETAILS
						Mov Ebx, Eax
						Invoke Refresh, hWnd
						Invoke GetTcpEntry, (-1), Addr szBuffer
						.If Eax
							Invoke GetCurrentProcess
							Mov Esi, Eax
							Invoke SetPrivileges, Esi, TRUE
							Mov Eax, Ebx
							.If Ax == IDM_MENU_CLOSE_PORT
								Lea Eax, szBuffer
								Mov [Eax].MIB_TCPROW.dwState, MIB_TCP_STATE_DELETE_TCB
								Invoke SetTcpEntry, Addr szBuffer
								.If Eax == NO_ERROR
									Invoke Sleep, 200
									Invoke RefreshTcpOpenPorts, hWnd
								.EndIf
							.ElseIf Ax == IDM_MENU_TERMINATE_PROCESS
								Invoke SetWaitCursor, hWnd
								Xor Ebx, Ebx
								Lea Edi, szBuffer
								Invoke OpenProcess, PROCESS_TERMINATE, FALSE, [Edi].MIB_TCPROW_OWNER_PID.dwOwningPid
								.If Eax
									Mov Ebx, Eax
									Mov [Edi].MIB_TCPROW.dwState, MIB_TCP_STATE_DELETE_TCB
									Invoke SetTcpEntry, Addr szBuffer
									Invoke TerminateProcess, Ebx, 0
								.EndIf
								.If Ebx
									Invoke CloseHandle, Ebx
									Invoke Sleep, 500
									Invoke RefreshTcpOpenPorts, hWnd
								.EndIf
								Invoke SetDefaultCursor
							.ElseIf Ax == IDM_MENU_DETAILS
								Mov bModalWindowOn, TRUE
								Invoke Create, TextStr("Details"), hWnd, ecModal, 0
								Mov bModalWindowOn, FALSE
							.EndIf
							Invoke SetPrivileges, Esi, FALSE
							Return TRUE
						.EndIf
					.EndIf
				.EndIf
			.EndIf
		.ElseIf Ax == CBN_SELCHANGE
			LoWord wParam
			.If Ax == IDC_NETMON_COMBO1
				Invoke SendMessage, hWndCombo, CB_GETCURSEL, 0, 0
				.If Eax != dwCurrentIndex
					Mov dwCurrentIndex, Eax
					Invoke SelectAdapter, (-1)
					Invoke ReadIfTable, TRUE
					Invoke InitAdapterValues
				.EndIf
				Invoke UpdateLights, TRUE, FALSE
				Invoke GetWindowItem, hWnd, IDC_NETMON_TABSTRIP1
				Invoke SetFocus, Eax
				Return TRUE
			.EndIf
		.EndIf
	.ElseIf uMsg == WM_NOTIFY
		.If wParam == IDC_NETMON_TABSTRIP1
			Mov Edi, lParam
			.If [Edi].NMHDR.code == TCN_SELCHANGE
				Invoke GetWindowItem, hWnd, IDC_NETMON_TABSTRIP1
				Invoke SendMessage, Eax, TCM_GETCURSEL, 0, 0
				.If Eax == 0		;Is Tab 0 (Activity)?
					Mov bTcpPortsTab, FALSE
					Mov bUdpPortsTab, FALSE
					Mov Esi, SW_SHOWNORMAL
				.ElseIf Eax == 1	;Is Tab 1 (TCP Ports)?
					Mov bTcpPortsTab, TRUE
					Mov bUdpPortsTab, FALSE
					Mov Esi, SW_HIDE
				.ElseIf Eax == 2	;Is Tab 2 (UDP Ports)?
					Mov bUdpPortsTab, TRUE
					Mov bTcpPortsTab, FALSE
					Mov Esi, SW_HIDE
				.EndIf
				Invoke GetWindowItem, hWnd, IDC_NETMON_GROUP1
				Invoke ShowWindow, Eax, Esi
				Invoke GetWindowItem, hWnd, IDC_NETMON_GROUP2
				Invoke ShowWindow, Eax, Esi
				Invoke GetWindowItem, hWnd, IDC_NETMON_GROUP3
				Invoke ShowWindow, Eax, Esi
				.If bTcpPortsTab
					Invoke ShowWindow, hWndLvTcp, SW_SHOWNORMAL
					Invoke ShowWindow, hWndLvUdp, SW_HIDE
					Invoke RefreshTcpOpenPorts, hWnd
					Mov Esi, SW_SHOWNORMAL
				.ElseIf bUdpPortsTab
					Invoke ShowWindow, hWndLvUdp, SW_SHOWNORMAL
					Invoke ShowWindow, hWndLvTcp, SW_HIDE
					Invoke RefreshUdpOpenPorts, hWnd
					Mov Esi, SW_SHOWNORMAL
				.Else
					Invoke ShowWindow, hWndLvTcp, SW_HIDE
					Invoke ShowWindow, hWndLvUdp, SW_HIDE
					Mov Esi, SW_HIDE
				.EndIf
				Invoke GetWindowItem, hWnd, IDC_NETMON_GRPLISTVIEW
				Mov Edi, Eax
				Invoke ShowWindow, Eax, Esi
				Invoke Refresh, Edi
			.EndIf
		.ElseIf wParam == IDC_NETMON_LISTVIEW1
			Mov Edi, lParam
			.If [Edi].NMHDR.code == NM_RCLICK
				Invoke GetCursorPos, Addr rc
				Lea Edi, szBuffer
				Mov [Edi].LV_HITTESTINFO.flags, LVHT_ONITEM
				Mov Eax, rc.left
				Mov [Edi].LV_HITTESTINFO.pt.x, Eax
				Mov Eax, rc.top
				Mov [Edi].LV_HITTESTINFO.pt.y, Eax
				Invoke ScreenToClient, hWndLvTcp, Addr [Edi].LV_HITTESTINFO.pt
				Invoke SendMessage, hWndLvTcp, LVM_HITTEST, 0, Edi
				Xor Edi, Edi
				Xor Esi, Esi
				.If Eax != (-1)
					Invoke GetTcpEntry, (-1), Addr szBuffer
					.If Eax
						Lea Eax, szBuffer
						.If [Eax].MIB_TCPROW_OWNER_PID.dwOwningPid != (-1)
							Inc Esi
						.EndIf
						Inc Edi
					.EndIf
				.EndIf
				Invoke EnableMenu, hTcpSubMenu, IDM_MENU_CLOSE_PORT, Edi
				Invoke EnableMenu, hTcpSubMenu, IDM_MENU_TERMINATE_PROCESS, Esi
				Invoke EnableMenu, hTcpSubMenu, IDM_MENU_DETAILS, Edi
				Invoke TrackPopupMenu, hTcpSubMenu, (TPM_LEFTALIGN Or TPM_LEFTBUTTON), rc.left, rc.top, 0, hWnd, NULL
				Return TRUE
			.ElseIf [Edi].NMHDR.code == NM_DBLCLK
				Invoke SendMessage, hWnd, WM_COMMAND, IDM_MENU_DETAILS, 0
				Return TRUE
			.ElseIf [Edi].NMHDR.code == LVN_KEYDOWN
				.If [Edi].NMLVKEYDOWN.wVKey == VK_RETURN
					Invoke SendMessage, hWnd, WM_COMMAND, IDM_MENU_DETAILS, NULL
					Ret
				.EndIf
			.ElseIf [Edi].NMHDR.code == LVN_HOTTRACK
				.If lPlatForm >= ecWin2K
					Mov Edi, lParam
					.If [Edi].NM_LISTVIEW.iItem != (-1) && !bRefreshingTcp
						Invoke GetTcpEntry, [Edi].NM_LISTVIEW.iItem, Addr szBuffer
						.If Eax
							.If lTimer
								Invoke KillTimer, hWnd, lTimer
								Mov lTimer, 0
							.EndIf
							Lea Edi, szBuffer
							Mov Ebx, [Edi].MIB_TCPROW_OWNER_PID.dwOwningPid
							Push [Edi].MIB_TCPROW_OWNER_PID.dwRemoteAddr
							Mov Esi, Edi
							Invoke RtlZeroMemory, Edi, SizeOf PROCESSENTRY32
							Add Esi, 128
							Mov Eax, Esi
							Mov Byte Ptr [Eax], ' '
							Inc Eax
							Invoke LoadAppString, IDS_PROCESS, Eax, 64
							Add Eax, Esi
							Inc Eax
							Mov Byte Ptr [Eax], ' '
							Inc Eax
							Invoke GetProcessInfo, Ebx, Eax, Edi
							Invoke lstrlen, Esi
							Add Eax, Esi
							Mov Byte Ptr [Eax], '-'
							Inc Eax
							Pop Ecx
							Invoke IPToStr, Ecx, Eax
							Invoke SetWindowText, hWnd, Esi
							Invoke SetTimer, hWnd, 20, 1200, NULL
							Mov lTimer, Eax
						.EndIf
					.EndIf
				.EndIf
			.ElseIf [Edi].NMHDR.code == LVN_COLUMNCLICK
				Mov Edx, [Edi].NM_LISTVIEW.iSubItem
				Mov lCurrentTdpSort, Edx
				.If Edx == 1
					Xor bLocalTcpDescending, 1
				.ElseIf Edx == 2
					Xor bRemoteTcpDescending, 1
				.ElseIf Edx == 3
					Xor bStateTcpDescending, 1
				.EndIf
				Invoke SendMessage, [Edi].NMHDR.hwndFrom, LVM_SORTITEMSEX, Edx, Addr CompareTcpFunction
				Invoke SendMessage, hWndLvTcp, LVM_GETNEXTITEM, (-1), LVNI_SELECTED
				Cmp Eax, (-1)
				Jne @F
				Xor Eax, Eax
@@:				Invoke SendMessage, hWndLvTcp, LVM_ENSUREVISIBLE, Eax, FALSE
			.EndIf
		.ElseIf wParam == IDC_NETMON_LISTVIEW2
			Mov Edi, lParam
			.If [Edi].NMHDR.code == LVN_COLUMNCLICK
				Mov Edx, [Edi].NM_LISTVIEW.iSubItem
				Mov lCurrentUdpSort, Edx
				.If Edx == 1
					Xor bLocalUdpDescending, 1
				.ElseIf Edx == 2
					Xor bRemoteUdpDescending, 1
				.ElseIf Edx == 3
					Xor bStateUdpDescending, 1
				.EndIf
				Invoke SendMessage, [Edi].NMHDR.hwndFrom, LVM_SORTITEMSEX, Edx, Addr CompareUdpFunction
				Invoke SendMessage, hWndLvUdp, LVM_GETNEXTITEM, (-1), LVNI_SELECTED
				Cmp Eax, (-1)
				Jne @F
				Xor Eax, Eax
@@:				Invoke SendMessage, hWndLvUdp, LVM_ENSUREVISIBLE, Eax, FALSE
			.ElseIf [Edi].NMHDR.code == NM_RCLICK
				Invoke GetCursorPos, Addr rc
				Lea Edi, szBuffer
				Mov [Edi].LV_HITTESTINFO.flags, LVHT_ONITEM
				Mov Eax, rc.left
				Mov [Edi].LV_HITTESTINFO.pt.x, Eax
				Mov Eax, rc.top
				Mov [Edi].LV_HITTESTINFO.pt.y, Eax
				Invoke ScreenToClient, hWndLvUdp, Addr [Edi].LV_HITTESTINFO.pt
				Invoke SendMessage, hWndLvUdp, LVM_HITTEST, 0, Edi
				Xor Esi, Esi
				.If Eax != (-1)
					Invoke GetUdpEntry, Addr szBuffer
					.If Eax
						Lea Eax, szBuffer
						.If [Eax].MIB_UDPROW_OWNER_PID.dwOwningPid != (-1)
							Inc Esi
						.EndIf
					.EndIf
				.EndIf
				Invoke EnableMenu, hUdpSubMenu, IDM_MENU_TERMINATE_PROCESS_UDP, Esi
				Invoke TrackPopupMenu, hUdpSubMenu, (TPM_LEFTALIGN Or TPM_LEFTBUTTON), rc.left, rc.top, 0, hWnd, NULL
				Return TRUE
			.EndIf
		.EndIf
	.ElseIf uMsg == WM_SYSCOMMAND
		.If wParam == MC_RESIZE
			Jmp @F
		.EndIf
	.ElseIf uMsg == WM_NCLBUTTONDBLCLK
@@:		Invoke GetWindowItem, hWnd, IDC_NETMON_TABSTRIP1
		Mov Ebx, Eax
		Invoke SendMessage, Eax, TCM_GETCURSEL, 0, 0
		.If Eax
			Invoke SendMessage, Ebx, TCM_SETCURSEL, 0, 0
			Lea Esi, szBuffer
			Mov [Esi].NMHDR.hwndFrom, Ebx
			Mov [Esi].NMHDR.idFrom, IDC_NETMON_TABSTRIP1
			Mov [Esi].NMHDR.code, TCN_SELCHANGE
			Invoke SendMessage, hWnd, WM_NOTIFY, IDC_NETMON_TABSTRIP1, Esi
		.EndIf
		Xor bSmallSize, 1
		Invoke SetMonitorSize, hWnd
		Return TRUE
	.ElseIf uMsg == WM_TRAYMESSAGE
		.If lParam == WM_LBUTTONDOWN
@@:			Invoke IsWindowEnabled, hWnd
			.If Eax
				Invoke SetForegroundWindow, hWnd
			.EndIf
			Return TRUE
		.ElseIf lParam == WM_LBUTTONDBLCLK
			Invoke IsWindowVisible, hWnd
			Or Eax, Eax
			Jnz @B
			Invoke SendMessage, hWnd, WM_COMMAND, IDM_MENU_MONITOR, NULL
			Ret
		.ElseIf lParam == WM_RBUTTONUP
			Invoke IsWindowEnabled, hWnd
			.If Eax
				Invoke SetForegroundWindow, hWnd
			.EndIf
		 	;Gets cursor coordinates
			Invoke GetCursorPos, Addr pt
		 	;Displays the menu in the right position
		 	.If bModalWindowOn
		 		Invoke MessageBeep, 0
		 	.Else
				Invoke TrackPopupMenu, hMainSubMenu, 0, pt.x, pt.y, 0, hWnd, NULL
			.EndIf
			Return TRUE
		.EndIf
	.ElseIf uMsg == WM_EXITSIZEMOVE
		Invoke SaveMonitorPosition, hWnd
	.ElseIf uMsg == WM_TIMER
		Mov Eax, wParam
		.If Eax == lTimer
			Invoke KillTimer, hWnd, lTimer
			Mov lTimer, 0
			Invoke SetWindowText, hWnd, App.Header
			Return TRUE
		.EndIf
	.ElseIf uMsg == WM_CLOSE
		Invoke CloseMonitorWindow, hWnd, FALSE
		Invoke SendMessage, hWndLBStr, LB_RESETCONTENT, 0, 0
		Invoke DestroyWindow, hWndLBStr
		Return TRUE
	.ElseIf uMsg == WM_DESTROY
		.If lTimer
			Invoke KillTimer, hWnd, lTimer
			Mov lTimer, 0
		.EndIf
		Invoke GetTickCount
		Mov Edi, Eax
		Add Edi, 1000
		Mov bDoThread, FALSE
		.While bThreadActive
			Invoke GetTickCount
			Cmp Eax, Edi
			Jge @F
			Invoke Sleep, 1
		.EndW
@@:		Invoke CloseHandle, hMutex
		Invoke Shell_NotifyIcon, NIM_DELETE, Addr IconData
		Invoke DestroyMeter, lMeterDownIndex
		Invoke DestroyMeter, lMeterUpIndex
		Invoke DestroyIcon, hIconBoth
		Invoke DestroyIcon, hIconDisconn
		Invoke DestroyIcon, hIconDownOff
		Invoke DestroyIcon, hIconDownOn
		Invoke DestroyIcon, hIconNone
		Invoke DestroyIcon, hIconReceive
		Invoke DestroyIcon, hIconSend
		Invoke DestroyIcon, hIconUpOff
		Invoke DestroyIcon, hIconUpOn
		Invoke DestroyCursor, hCursorHand
		Invoke DestroyMenu, hMainMenu
		Invoke DestroyMenu, hTcpMenu
		Invoke DestroyMenu, hUdpMenu
		Invoke GlobalFree, lpPtr
		Invoke FreeAdaptersMemory
		.If hIpHlpApi
			Invoke FreeLibrary, hIpHlpApi
		.EndIf
	.EndIf
	Return FALSE
NetMonProcedure EndP

NetMonThread Proc Private Uses Ebx Edi Esi lpParameter:LPVOID
	Mov bThreadActive, TRUE
L1:	Invoke ReadIfTable, TRUE
	Invoke InitAdapterValues
	Invoke GetTickCount
	Add Eax, 500
	Mov dwCounter1, Eax
	Add Eax, 500
	Mov dwCounter2, Eax
	Mov dwCounter3, 0
	.If bRealIPAddress
		Mov bRealIPAddress, FALSE
		Invoke GetRealIP
	.EndIf
L2:	Cmp bDoThread, FALSE
	Je L8
	Cmp bShowIcon, FALSE
	Jne @F
	Cmp IconData.cbSize, 0
	Je @F
	Invoke Shell_NotifyIcon, NIM_ADD, Addr IconData
	Mov bShowIcon, Eax
	Invoke RegisterWindowMessage, TextStrA("TaskbarCreated")
	Mov WM_TASKBARCREATED, Eax
	Invoke GetRealIP
@@:	Invoke GetTickCount
	Cmp lAutoRefreshPorts, 0
	Je @F
	Cmp Eax, dwCounter3
	Jl @F
	Push Eax
	Mov Ecx, Eax
	Mov Eax, 1000
	Mul lAutoRefreshPorts
	Add Eax, Ecx
	.If (!bScrolling)
		Mov dwCounter3, Eax
		.If bTcpPortsTab
			Invoke RefreshTcpOpenPorts, IconData.hwnd
		.ElseIf bUdpPortsTab
			Invoke RefreshUdpOpenPorts, IconData.hwnd
		.EndIf
	.EndIf
	Pop Eax
@@:	Cmp Eax, dwCounter2
	Jge L6
	Cmp Eax, dwCounter1
	Jge L4
	Invoke SleepEx, 1, TRUE
	Jmp L2
L4:	Add Eax, 500
	Mov dwCounter1, Eax
	Jmp L2
L6:	Add Eax, 500
	Mov dwCounter1, Eax
	Add Eax, 500
	Mov dwCounter2, Eax
	.If dwCountDown != (-1)
		Dec dwCountDown
		Jg @F
		Invoke ShutDownPC
		Jmp L8
	.EndIf
@@:	Invoke GetIPAddressTables
	Cmp Eax, (-1)
	Je @F
	Cmp Eax, dwNumConns
	Je @F
	Invoke InitInterfaces
	Jmp L1
@@:	Invoke ReadIfTable, TRUE
	.If (!Eax)
		Invoke InitInterfaces
	.EndIf
	Invoke SetIPAddressString, (-1)
	Mov Eax, dwCurrentIndex
	Cmp Eax, (-1)
	Jne @F
	Mov dwNetState, STATUS_DISCONN
	Mov bRealIPAddress, FALSE
	Mov Eax, hIconDisconn
	Cmp Eax, IconData.hIcon
	Je L2
	Invoke SetIcons, Eax
	Jmp L2
@@:	Shl Eax, 2
	Add Eax, Offset dwIfTableIndex
	Mov Ebx, [Eax]
	Or Ebx, Ebx
	Jz L2

	Invoke QueryPerformanceFrequency, Addr PERFreq
	Push DWord Ptr PERFCnt + 4           ; HIGH
	Push DWord Ptr PERFCnt               ; LOW
	Invoke QueryPerformanceCounter, Addr PERFCnt
	Pop Eax                              ; LOW
	Pop Edx                              ; HIGH
	.If Eax || Edx                       ; Si EXISTE el valor anterior de PERFCnt
		Move DWord Ptr PERFAux, DWord Ptr PERFCnt
		Move DWord Ptr PERFAux + 4, DWord Ptr PERFCnt + 4
		Sub DWord Ptr PERFAux, Eax       ; SUB LOW
		Sbb DWord Ptr PERFAux + 4, Edx   ; SUB WITH BORROW HIGH
		.If (DWord Ptr PERFAux) || (DWord Ptr PERFAux + 4)     ; SI LA DIFERENCIA ES POSITIV
			;----PROVISORIO- EN EL FUTURO PUEDEN TOMAR VALORES SUPERIORES A UN DWORD------
			;----Y SE REEMPLAZA POR "MULDIV" POR EL EQUIVALENTE CON EL COPROCESADOR-------
			Invoke MulDiv, DWord Ptr PERFAux, 1000000, DWord Ptr PERFreq
;			Fild QWord Ptr PERFAux
;			Push 1000000
;			Fimul DWord Ptr [Esp]
;			Fild QWord Ptr PERFreq
;			Fdivp St(1), St(0)
;			Frndint
;			Fistp DWord Ptr [Esp]
;			Pop Eax
			Mov SpeedScale, Eax
		.Else
			Mov SpeedScale, 0            ; Si hay problemas es CERO
		.EndIf
	.Else
		Mov SpeedScale, 0                ; Si NO EXISTE valor anterior de PERFCnt
	.EndIf

	Mov Edi, [Ebx].ADAPTER_DATA.dwBytesIn
	Mov Esi, [Ebx].ADAPTER_DATA.dwBytesOut
	Invoke UpdateLights, TRUE, FALSE
	Invoke FilterData, Edi, Addr lLastBytesInIndex, Addr lpLastBytesIn, FilterMode
	Mov [Ebx].ADAPTER_DATA.dwLastSpeedIn, Eax
	.If bCountDownActive
		.If (dwCountDown != (-1))
			Push Eax
			Invoke SetCaption, dwCountDown
			Pop Eax
		.EndIf
		.If (Eax < SDWord Ptr dwMinBytes)
			.If dwCountDown == (-1)
				Mov Eax, lCountSeconds
				Mov dwCountDown, Eax
			.EndIf
		.Else
			Mov dwCountDown, (-1)
		.EndIf
	.Else
		Mov dwCountDown, (-1)
	.EndIf
	Invoke FilterData, Esi, Addr lLastBytesOutIndex, Addr lpLastBytesOut, FilterMode
	Mov [Ebx].ADAPTER_DATA.dwLastSpeedOut, Eax
	Mov [Ebx].ADAPTER_DATA.dwLastBytesIn, Edi
	Mov [Ebx].ADAPTER_DATA.dwLastBytesOut, Esi
	Jmp L2
L8:	Xor Eax, Eax
	Mov bThreadActive, Eax
	Ret
NetMonThread EndP

NetMonListView1 Proc Private hWnd:HWND, uMsg:ULONG, wParam:WPARAM, lParam:LPARAM
	.If uMsg == WM_VSCROLL
		.If wParam == SB_ENDSCROLL
			Mov bScrolling, FALSE
		.Else
			Mov bScrolling, TRUE
		.EndIf
	.EndIf
	Return FALSE
NetMonListView1 EndP

NetMonListView2 Proc Private hWnd:HWND, uMsg:ULONG, wParam:WPARAM, lParam:LPARAM
	Invoke NetMonListView1, hWnd, uMsg, wParam, lParam
	Ret
NetMonListView2 EndP

ActivateCountDown Proc Private Uses Ebx
	Xor Eax, Eax
	.If bCountDownActive
		.If b10Percent
			Invoke ReadIfTable, TRUE
			Mov Eax, dwCurrentIndex
			Shl Eax, 2
			Add Eax, Offset dwIfTableIndex
			Mov Ebx, [Eax]
			.If Ebx
				Mov Eax, [Ebx].ADAPTER_DATA.dwLastSpeedIn
				Mov Ecx, 10
				Xor Edx, Edx
				IDiv Ecx
			.Else
				Mov Eax, 100000
			.EndIf
		.Else
			Invoke lstrcpy, Addr szBuffer, TextStr("100")
			Invoke GetRegistryValueA, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szMinKiloBytes, Addr szBuffer
			Invoke ValueA, Addr szBuffer
			Mov Ecx, 1024
			IMul Ecx
		.EndIf
	.EndIf
	Mov dwMinBytes, Eax
	Invoke SetCaption, lCountSeconds
	Ret
ActivateCountDown EndP

AddListViewColumn Proc hListView:HWND, lpszText:LPSTR, lWidth:LONG, lPos:LONG, lAlignment:LONG
	Local lvc:LVCOLUMN

	Mov lvc.imask, (LVCF_FMT Or LVCF_TEXT Or LVCF_WIDTH)
	Mov Eax, lAlignment
	Mov lvc.fmt, Eax
	Mov Eax, lWidth
	Mov lvc.lx, Eax
	Mov Eax, lpszText
	Mov lvc.pszText, Eax
	Invoke lstrlen, lpszText
	Mov lvc.cchTextMax, Eax
	Mov lvc.iSubItem, 0
	Mov lvc.iImage, 0
	Mov lvc.iOrder, 0
	Invoke SendMessage, hListView, LVM_INSERTCOLUMN, lPos, Addr lvc
	Ret
AddListViewColumn EndP

CheckMainWindow Proc Private hWnd:HWND
	Invoke IsWindowVisible, hWnd
	Or Eax, Eax
	Jnz @F
	Invoke SendMessage, hWnd, WM_COMMAND, IDM_MENU_MONITOR, NULL
	Invoke Sleep, 150
@@:	Cmp bSmallSize, FALSE
	Je @F
	Mov bSmallSize, FALSE
	Invoke SetMonitorSize, hWnd
@@:	Ret
CheckMainWindow EndP

CheckMenu Proc Private ulMenu:ULONG
	Invoke GetMenuState, hMainSubMenu, ulMenu, MF_BYCOMMAND
	And Eax, MFS_CHECKED
	.If Zero?
		Mov Eax, MFS_CHECKED
	.Else
		Mov Eax, MFS_UNCHECKED
	.EndIf
	Push Eax
	Or Eax, MF_BYCOMMAND
	Invoke CheckMenuItem, hMainSubMenu, ulMenu, Eax
	Pop Eax
	Ret
CheckMenu EndP

CloseMonitorWindow Proc Private hWnd:HWND, bEnd:BOOL
	.If bEnd
		Invoke IsWindowVisible, hWnd
	.Else
		Invoke ShowWindow, hWnd, SW_HIDE
		Invoke CheckMenu, IDM_MENU_MONITOR
		Xor Eax, Eax
	.EndIf
	Invoke wsprintf, Addr szBuffer, Addr szFormat, Eax
	Invoke SetRegistryValueA, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szVisible, Addr szBuffer
	Ret
CloseMonitorWindow EndP

CompareTcpFunction Proc Private Uses Ebx Edi Esi lParam1:LPARAM, lParam2:LPARAM, lParamSort:LPARAM
	Local lvi:LVITEM

	Lea Edi, szBuffer
	Add Edi, 192
	Mov Esi, Edi
	Add Esi, 16
	Mov Eax, lParamSort
	.If Eax
		Mov lvi.iSubItem, Eax
		Mov lvi.imask, LVIF_TEXT
		Mov Eax, lParam1
		Mov lvi.iItem, Eax
		Mov lvi.pszText, Edi
		Mov lvi.cchTextMax, 12
		Invoke SendMessage, hWndLvTcp, LVM_GETITEM, 0, Addr lvi
		Mov Eax, lParam2
		Mov lvi.iItem, Eax
		Mov lvi.pszText, Esi
		Mov lvi.cchTextMax, 12
		Invoke SendMessage, hWndLvTcp, LVM_GETITEM, 0, Addr lvi
		.If DWord Ptr lParamSort > 2
			.If bStateTcpDescending
				Xchg Edi, Esi
			.EndIf
			Invoke lstrcmpi, Edi, Esi
		.Else
			.If lParamSort == 1
				Mov Ebx, bLocalTcpDescending
			.ElseIf lParamSort == 2
				Mov Ebx, bRemoteTcpDescending
			.EndIf
			Invoke ValueA, Edi
			Mov Edx, Eax
			Invoke ValueA, Esi
			.If Ebx
				Xchg Eax, Edx
			.EndIf
			Sub Eax, Edx	;Eax < 0 = De petit a gran
		.EndIf
		Ret
	.EndIf
	Xor Eax, Eax
	Ret
CompareTcpFunction EndP

CompareUdpFunction Proc Private Uses Ebx Edi Esi lParam1:LPARAM, lParam2:LPARAM, lParamSort:LPARAM
	Local lvi:LVITEM

	Lea Edi, szBuffer
	Add Edi, 192
	Mov Esi, Edi
	Add Esi, 16
	Mov Eax, lParamSort
	.If Eax
		Mov lvi.iSubItem, Eax
		Mov lvi.imask, LVIF_TEXT
		Mov Eax, lParam1
		Mov lvi.iItem, Eax
		Mov lvi.pszText, Edi
		Mov lvi.cchTextMax, 12
		Invoke SendMessage, hWndLvUdp, LVM_GETITEM, 0, Addr lvi
		Mov Eax, lParam2
		Mov lvi.iItem, Eax
		Mov lvi.pszText, Esi
		Mov lvi.cchTextMax, 12
		Invoke SendMessage, hWndLvUdp, LVM_GETITEM, 0, Addr lvi
		.If DWord Ptr lParamSort > 2
			.If bStateUdpDescending
				Xchg Edi, Esi
			.EndIf
			Invoke lstrcmpi, Edi, Esi
		.Else
			.If lParamSort == 1
				Mov Ebx, bLocalUdpDescending
			.ElseIf lParamSort == 2
				Mov Ebx, bRemoteUdpDescending
			.EndIf
			Invoke ValueA, Edi
			Mov Edx, Eax
			Invoke ValueA, Esi
			.If Ebx
				Xchg Eax, Edx
			.EndIf
			Sub Eax, Edx	;Eax < 0 = De petit a gran
		.EndIf
		Ret
	.EndIf
	Xor Eax, Eax
	Ret
CompareUdpFunction EndP

ConvertToScale Proc Private dwBytesSecond:DWord
	Mov Eax, dwBytesSecond
	Or Eax, Eax
	Jnz @F
	Ret
@@:	Cmp Eax, 101
	Jg @F
	Mov Eax, 102
@@:	Cmp bBits, FALSE
	Je @F
	Shl Eax, 3
@@:	Ret
ConvertToScale EndP

EnableMenu Proc Private hMenu:HMENU, ulID:ULONG, bEnable:BOOL
	Mov Eax, MF_GRAYED
	Cmp bEnable, FALSE
	Je @F
	Mov Eax, MF_ENABLED
@@:	Or Eax, MF_BYCOMMAND
	Invoke EnableMenuItem, hMenu, ulID, Eax
	Ret
EnableMenu EndP

FilterData Proc Private Uses Edi Esi QData:DWord, BufIndxPtr:DWord, BufPtr:DWord, FMode:DWord
    Mov Edi, BufIndxPtr          ; Rdi == Index Ptr
    Mov Ecx, [Edi]                ; Rcx == Index value
    And Ecx, 0FH                 ; Acota el valor:  "0 <=  Index <=  15"
	Mov Esi, BufPtr

	Mov Eax, QData
	Cmp FMode, 0                 ; sin filtro
	Jz L2
	Cmp FMode, 2                 ; con filtro digital
	Jz L1
	Mov DWord Ptr [Esi + Ecx * 4], Eax
    Cld                          ; INCREMENT STRING FUNCTIONS
    Cmp Ecx, [Edi]                ; si son los primeros valores menores a 16, se promedian solamente esos primeros
    Jz L3                        ; si son iguales, quiere decir que Index es menor a 16.
	Mov Ecx, 16                  ; promedio con 16 valores DWORD
    Xor Edx, Edx                 ; suma de valores
@@: Lodsd
    Add Edx, Eax
    Loop @B
    Shr Edx, 4                   ; suma / 16
    Mov Eax, Edx                 ; suma -> Rax
	Inc DWord Ptr [Edi]            ; Index = Index + 1
    Jmp L2
L3:     Xor Edx, Edx             ; Promedio de los primeros valores menores a 16
        Inc Ecx                  ; Cantidad de valores referida a "1", porque estaban referidas a "0".
        Push Ecx
@@:     Lodsd
        Add Edx, Eax
        Loop @B
        Mov Eax, Edx             ; Rax <- Suma
        Xor Edx, Edx             ; Rdx <- 0
        Pop Ecx
        Div Ecx                  ; Suma / Cantidad de valores tomados
	    Inc DWord Ptr [Edi]        ; Index = Index + 1
L2:
;                 ; rutina para mostrar los resultados PROVISORIO
;                 Push Eax
;                 Push Eax
;                         Invoke wsprintf, Addr szBuffer, TextAddr("FMode: %d, Vi: %d  , Vo: %d"), FMode, QData, Eax
;                         Invoke OutputString, Addr szBuffer, FALSE
;                 Pop Eax
;                 Pop Eax
    Ret

;---LOW PASS FILTER FIRST ORDER - CTEFILTER == FILTER TAU == (R*C)--------------------------------------------------
L1:  Fild DWord Ptr [Esi]                              ; Vo Ant
     Fmul CTEFILTER1                                    ; (Vo Ant) * CTEFILTER1
     Fild DWord Ptr QData                               ; Vi
     Faddp St(1), St(0)                                ; (Vo Ant) * CTEFILTER1 + Vi
     Fld1
     Fadd CTEFILTER1                                    ; 1 + CTEFILTER1
     Fdivp St(1), St(0)                               ; [(Vo Ant) * CTEFILTER1 + Vi] / (1 + CTEFILTER1)
     Frndint
     Fistp DWord Ptr [Esi]                                ; Vo -> Vo Ant
     Mov Eax, [Esi]                                      ; Vo -> Rax
     Jmp L2                                             ; SALIDA

FilterData EndP

FreeAdaptersMemory Proc Private Uses Edi
	Lea Edi, dwIfTableIndex
	Mov Ecx, 64
L2:	Mov Eax, [Edi]
	Or Eax, Eax
	Jz @F
	Push Ecx
	Invoke GlobalFree, Eax
	Mov DWord Ptr [Edi], 0
	Pop Ecx
@@:	Add Edi, 4
	Loop L2
	Ret
FreeAdaptersMemory EndP

GetAppStrings Proc Private Uses Edi Esi ulResID:ULONG
	Local dwLength:DWord

	Invoke FindResource, App.Instance, ulResID, RT_FILEDATA
	.If Eax
		Mov Edi, Eax
		Invoke SizeofResource, App.Instance, Eax
		Mov dwLength, Eax
		Invoke LoadResource, App.Instance, Edi
		.If Eax
			Invoke LockResource, Eax
			Mov Esi, Eax
			Mov Eax, dwLength
			Add Eax, 2
			Invoke VirtualAlloc, 0, Eax, MEM_COMMIT, PAGE_READWRITE
			Mov Edi, Eax
			Invoke RtlMoveMemory, Edi, Esi, dwLength
			Xor Eax, Eax
			.While (Eax < SDWord Ptr dwLength)
				Xor Byte Ptr [Edi + Eax], 0AAH
				Inc Eax
			.EndW
			Invoke StoreAppStrings, Edi
			Invoke VirtualFree, Edi, 0, MEM_RELEASE
			Ret
		.EndIf
	.EndIf
	Xor Eax, Eax
	Ret
GetAppStrings EndP

GetIPAddressTables Proc Private
	Invoke GetIpAddrTable, lpPtr, Addr dwPtrSize, FALSE
	Cmp Eax, ERROR_INSUFFICIENT_BUFFER
	Jne @F
	Invoke GlobalFree, lpPtr
	Invoke GlobalAlloc, GPTR, dwPtrSize
	Mov lpPtr, Eax
	Invoke GetIpAddrTable, lpPtr, Addr dwPtrSize, FALSE
@@:	Cmp Eax, NO_ERROR
	Je @F
	Mov Eax, (-1)
	Ret
@@:	Mov Eax, lpPtr
	Mov Eax, [Eax]	;Eax = Number of entries
	Ret
GetIPAddressTables EndP

GetMeterRegistrySettings Proc Private
	Invoke GetRegistryValueA, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szBits, Addr szBuffer
	.If Eax
		Invoke ValueA, Addr szBuffer
		Mov bBits, Eax
	.EndIf
	Invoke GetRegistryValueA, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szFilterMode, Addr szBuffer
	.If Eax
		Invoke ValueA, Addr szBuffer
		Mov FilterMode, Eax
	.EndIf
	Invoke GetRegistryValueA, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szKBValue, Addr szBuffer
	.If Eax
		Invoke ValueA, Addr szBuffer
		.If (Eax != 1000 && Eax != 1024)
			Mov Eax, 1024
		.EndIf
		Mov KBValue, Eax
	.EndIf
	Invoke SetKBValues
	Invoke GetRegistryValueA, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szMeterDownColor, Addr szBuffer
	.If Eax
		Invoke ValueA, Addr szBuffer
		Mov crMeterDownColor, Eax
	.EndIf
	Invoke GetRegistryValueA, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szMeterUpColor, Addr szBuffer
	.If Eax
		Invoke ValueA, Addr szBuffer
		Mov crMeterUpColor, Eax
	.EndIf
	Invoke GetRegistryValueA, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szMeterDownMaxValueEnum, Addr szBuffer
	.If Eax
		Invoke ValueA, Addr szBuffer
		Mov lMeterDownMaxValueEnum, Eax
	.EndIf
	Invoke CheckMeterMaxValue, lMeterDownMaxValueEnum, Addr lMeterDownMaxValue
	Invoke GetRegistryValueA, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szMeterUpMaxValueEnum, Addr szBuffer
	.If Eax
		Invoke ValueA, Addr szBuffer
		Mov lMeterUpMaxValueEnum, Eax
	.EndIf
	Invoke CheckMeterMaxValue, lMeterUpMaxValueEnum, Addr lMeterUpMaxValue
	Ret
GetMeterRegistrySettings EndP

GetTcpOpenPorts Proc Private Uses Ebx Edi Esi
	Local lStructSize:LONG, lp:LPVOID, lvi:LVITEM

	Mov Eax, SizeOf MIB_TCPROW
	.If lpGetExtendedTcpTable
		Mov Eax, SizeOf MIB_TCPROW_OWNER_PID
	.EndIf
	Mov lStructSize, Eax
	Invoke SendMessage, hWndLvTcp, LVM_DELETEALLITEMS, 0, 0
	Invoke ReadTcpTableEx
	.If Eax
		Mov lp, Eax
		Mov Esi, Eax
		Mov lvi.imask, LVIF_TEXT
		Xor Edi, Edi
		Mov Ebx, [Esi]
		Add Esi, 4
		Lea Eax, szBuffer
		Mov lvi.pszText, Eax
		.While Ebx
			Mov Word Ptr szBuffer[0], 0
			Mov lvi.iItem, Edi
			Mov lvi.iSubItem, 0
			Invoke SendMessage, hWndLvTcp, LVM_INSERTITEM, 0, Addr lvi
			Mov lvi.iItem, Eax
			Inc lvi.iSubItem
			Mov Eax, [Esi + 8]		;dwLocalPort
			Invoke PortToStr, Eax, Addr szBuffer
			Invoke SendMessage, hWndLvTcp, LVM_SETITEM, 0, Addr lvi
			Inc lvi.iSubItem
			Mov Eax, [Esi + 16]		;dwRemotePort
			Invoke PortToStr, Eax, Addr szBuffer
			Invoke SendMessage, hWndLvTcp, LVM_SETITEM, 0, Addr lvi
			Inc lvi.iSubItem
			Mov Eax, [Esi]			;dwState
			Invoke GetStateString, Eax, Addr szBuffer
			Invoke SendMessage, hWndLvTcp, LVM_SETITEM, 0, Addr lvi
			Add Esi, lStructSize ;SizeOf MIB_TCPROW
			Inc Edi
			Dec Ebx
		.EndW
		Invoke GlobalFree, lp
		Invoke SendMessage, hWndLvTcp, LVM_SORTITEMSEX, lCurrentTdpSort, Addr CompareTcpFunction
	.EndIf
	Ret
GetTcpOpenPorts EndP

GetUdpOpenPorts Proc Private Uses Ebx Edi Esi
	Local lStructSize:LONG, lp:LPVOID, lvi:LVITEM
	Local ProcessEntry:PROCESSENTRY32

	Mov Eax, SizeOf MIB_UDPROW
	.If lpGetExtendedUdpTable
		Mov Eax, SizeOf MIB_UDPROW_OWNER_PID
	.EndIf
	Mov lStructSize, Eax
	Invoke SendMessage, hWndLvUdp, LVM_DELETEALLITEMS, 0, 0
	Invoke ReadUdpTableEx
	.If Eax
		Mov lp, Eax
		Mov Esi, Eax
		Mov lvi.imask, LVIF_TEXT
		Xor Edi, Edi
		Mov Ebx, [Esi]
		Add Esi, 4
		Lea Eax, szBuffer
		Mov lvi.pszText, Eax
		.While Ebx
			Mov Word Ptr szBuffer[0], 0
			Mov lvi.iItem, Edi
			Mov lvi.iSubItem, 0
			Invoke SendMessage, hWndLvUdp, LVM_INSERTITEM, 0, Addr lvi
			Mov lvi.iItem, Eax
			Inc lvi.iSubItem
			Mov Eax, [Esi + 4]		;dwLocalPort
			Invoke PortToStr, Eax, Addr szBuffer
			Invoke SendMessage, hWndLvUdp, LVM_SETITEM, 0, Addr lvi
			Inc lvi.iSubItem
			Mov Eax, [Esi]			;dwLocalAddr
			Invoke IPToStr, Eax, Addr szBuffer
			Invoke SendMessage, hWndLvUdp, LVM_SETITEM, 0, Addr lvi
			Inc lvi.iSubItem
			Mov Edx, (-1)
			.If lpGetExtendedUdpTable
				Mov Edx, [Esi + 8]	;dwOwningPid
			.EndIf
			Invoke GetProcessInfo, Edx, Addr szBuffer, Addr ProcessEntry
			Invoke SendMessage, hWndLvUdp, LVM_SETITEM, 0, Addr lvi
			Add Esi, lStructSize ;SizeOf MIB_UDPROW
			Inc Edi
			Dec Ebx
		.EndW
		Invoke GlobalFree, lp
		Invoke SendMessage, hWndLvUdp, LVM_SORTITEMSEX, lCurrentUdpSort, Addr CompareUdpFunction
	.EndIf
	Ret
GetUdpOpenPorts EndP

GetRealIP Proc Private Uses Esi
	Local dwParameter:DWord

	.If (!bRealIPAddress)
		Invoke CreateThread, 0, 0, Addr RemoteIPThread, Addr dwParameter, 0, NULL
		Invoke CloseHandle, Eax
	.EndIf
	Ret
GetRealIP EndP

GetSpeedString Proc Private Uses Esi dwValue:DWord, dwDiv1:DWord, dwDiv2:DWord
	Mov Eax, dwValue
	Xor Edx, Edx
	Div dwDiv1
	Mov Esi, Edx
	Invoke wsprintf, Addr szBuffer, Addr szFormat, Eax
	Invoke lstrlen, Addr szBuffer
	Xchg Eax, Esi
	Add Esi, Offset szBuffer
	Xor Edx, Edx
	Div dwDiv2
	Cmp Eax, 10
	Jl @F
	Mov Eax, 9
@@:	Mov Cl, [sDecimal]
	Mov Byte Ptr [Esi], Cl
	Inc Esi
	Invoke wsprintf, Esi, Addr szFormat, Eax
	Ret
GetSpeedString EndP

GetTcpEntry Proc Private Uses Ebx Edi Esi lItem:LONG, lpMibTcpRow:DWord
	Local lStructSize:LONG,lvi:LVITEM

	Mov Edi, lpMibTcpRow
	Mov Eax, lItem
	.If Eax == (-1)
		Invoke SendMessage, hWndLvTcp, LVM_GETNEXTITEM, (-1), LVNI_SELECTED
	.EndIf
	.If (Eax != (-1))
		Mov Edx, SizeOf MIB_TCPROW
		.If lpGetExtendedTcpTable
			Mov Edx, SizeOf MIB_TCPROW_OWNER_PID
		.EndIf
		Mov lStructSize, Edx
		Mov lvi.iItem, Eax
		Mov lvi.imask, LVIF_TEXT
		Mov lvi.iSubItem, 1
		Lea Eax, szBuffer
		Mov lvi.pszText, Eax
		Mov lvi.cchTextMax, 12
		Invoke SendMessage, hWndLvTcp, LVM_GETITEM, 0, Addr lvi
		Invoke ValueA, Addr szBuffer
		Push Eax
		Inc lvi.iSubItem
		Invoke SendMessage, hWndLvTcp, LVM_GETITEM, 0, Addr lvi
		Invoke ValueA, Addr szBuffer
		Push Eax
		Invoke ReadTcpTableEx
		Pop Edx
		Pop Ecx
		.If Eax
			Mov Esi, Eax
			Push Eax
			Xchg Cl, Ch
			Xchg Dl, Dh
			Mov Ebx, [Esi]
			Add Esi, 4
			.While Ebx
				.If Ecx == DWord Ptr [Esi + 8] && Edx == DWord Ptr [Esi + 16]
					Mov DWord Ptr [Edi + 8 ], Ecx	;Local port
					Mov DWord Ptr [Edi + 16], Edx	;dwRemotePort
					Mov Eax, DWord Ptr [Esi]	;dwState
					Mov DWord Ptr [Edi], Eax
					Mov Eax, DWord Ptr [Esi + 4]	;dwLocalAddr
					Mov DWord Ptr [Edi + 4], Eax
					Mov Eax, DWord Ptr [Esi + 12]	;dwRemoteAddr
					Mov DWord Ptr [Edi+ 12], Eax
					Mov DWord Ptr [Edi+ 20], (-1)
					.If lpGetExtendedTcpTable
						Mov Eax, DWord Ptr [Esi + 20]	;dwOwningPid
						Mov DWord Ptr [Edi+ 20], Eax
					.EndIf
					Pop Eax
					Invoke GlobalFree, Eax
					Mov Eax, TRUE
					Ret
				.EndIf
				Add Esi, lStructSize
				Dec Ebx
			.EndW
			Pop Eax
			Invoke GlobalFree, Eax
		.EndIf
	.EndIf
	Xor Eax, Eax
	Ret
GetTcpEntry EndP

GetUdpEntry Proc Private Uses Ebx Edi Esi lpMibUdpRow:DWord
	Local lStructSize:LONG,lvi:LVITEM

	Mov Edi, lpMibUdpRow
	Invoke SendMessage, hWndLvUdp, LVM_GETNEXTITEM, (-1), LVNI_SELECTED
	.If (Eax != (-1))
		Mov Edx, SizeOf MIB_UDPROW
		.If lpGetExtendedUdpTable
			Mov Edx, SizeOf MIB_UDPROW_OWNER_PID
		.EndIf
		Mov lStructSize, Edx
		Mov lvi.iItem, Eax
		Mov lvi.imask, LVIF_TEXT
		Mov lvi.iSubItem, 1
		Lea Eax, szBuffer
		Mov lvi.pszText, Eax
		Mov lvi.cchTextMax, 16
		Invoke SendMessage, hWndLvUdp, LVM_GETITEM, 0, Addr lvi
		Invoke ValueA, Addr szBuffer
		Push Eax
		Inc lvi.iSubItem
		Invoke SendMessage, hWndLvUdp, LVM_GETITEM, 0, Addr lvi
		Invoke StrToIP, Addr szBuffer
		Push Eax
		Invoke ReadUdpTableEx
		Pop Edx
		Pop Ecx
		.If Eax
			Mov Esi, Eax
			Push Eax
			Xchg Cl, Ch
			;Xchg Dl, Dh
			Mov Ebx, [Esi]
			Add Esi, 4
			.While Ebx
				.If Ecx == DWord Ptr [Esi + 4] && Edx == DWord Ptr [Esi]
					Mov DWord Ptr [Edi], Edx		;dwLocalAddr
					Mov DWord Ptr [Edi + 4], Ecx	;Local port
					.If lpGetExtendedUdpTable
						Mov Eax, DWord Ptr [Esi + 8]	;dwOwningPid
						Mov DWord Ptr [Edi + 8], Eax
					.EndIf
					Pop Eax
					Invoke GlobalFree, Eax
					Mov Eax, TRUE
					Ret
				.EndIf
				Add Esi, lStructSize
				Dec Ebx
			.EndW
			Pop Eax
			Invoke GlobalFree, Eax
		.EndIf
	.EndIf
	Xor Eax, Eax
	Ret
GetUdpEntry EndP

InitAdapterValues Proc Private Uses Ebx
	Mov Eax, dwCurrentIndex
	Cmp Eax, (-1)
	Jne @F
	Ret
@@:	Shl Eax, 2
	Add Eax, Offset dwIfTableIndex
	Mov Ebx, [Eax]		;Get adapter data address
	Invoke UpdateBytes, TRUE
	Invoke UpdateSpeed, 0, IDC_NETMON_STCSPEEDIN, Addr [Ebx].ADAPTER_DATA.dwLastSpeedIn, TRUE
	Invoke UpdateSpeed, 0, IDC_NETMON_STCSPEEDOUT, Addr [Ebx].ADAPTER_DATA.dwLastSpeedOut, TRUE
	Invoke SetIPAddressString, Ebx
	Mov Eax, [Ebx].ADAPTER_DATA.dwBytesIn
	Mov [Ebx].ADAPTER_DATA.dwLastSpeedIn, Eax
	Or Eax, Eax
	Jz @F
	Dec Eax
@@:	Mov [Ebx].ADAPTER_DATA.dwLastBytesIn, Eax
	Mov Eax, [Ebx].ADAPTER_DATA.dwBytesOut
	Mov [Ebx].ADAPTER_DATA.dwLastSpeedOut, Eax
	Or Eax, Eax
	Jz @F
	Dec Eax
@@:	Mov [Ebx].ADAPTER_DATA.dwLastBytesOut, Eax
	Ret
InitAdapterValues EndP

InitInterfaces Proc Private Uses Ebx Edi Esi
	Xor Ebx, Ebx
	Invoke FreeAdaptersMemory
	Lea Edi, dwIfTableIndex
	Invoke SendMessage, hWndCombo, CB_RESETCONTENT, 0, 0
	Cmp dwCurrentIndex, (-1)
	Jne @F
	Mov dwCurrentIndex, 0
@@:	Invoke GetIPAddressTables
	Cmp Eax, (-1)
	Je L4
	Mov Esi, lpPtr
	Mov Ecx, Eax	;Ecx = Number of entries
	Mov dwNumConns, Eax
	Add Esi, 4
	Lea Esi, [Esi]	;Esi = Pointer to first MIB_IPADDRROW struct
L2:	Push Ecx
	Mov Eax, [Esi].MIB_IPADDRROW.dwIndex
	Mov MibIfRow.dwIndex, Eax
	Invoke GetIfEntry, Addr MibIfRow
	.If MibIfRow.dwType != MIB_IF_TYPE_LOOPBACK || dwNumConns < 2
		Invoke GlobalAlloc, GPTR, SizeOf ADAPTER_DATA
		Mov Edx, Eax
		Cmp MibIfRow.dwInOctets, 0
		Je @F
		Or Ebx, Ebx
		Jnz @F
		Mov Eax, Edi
		Sub Eax, Offset dwIfTableIndex
		Shr Eax, 2
		Mov dwCurrentIndex, Eax
		Mov Ebx, TRUE
@@:		Mov [Edi], Edx
		Mov Eax, MibIfRow.dwIndex
		Mov [Edx].ADAPTER_DATA.dwIndex, Eax
		Mov Eax, MibIfRow.dwType
		Mov [Edx].ADAPTER_DATA.dwType, Eax
		Mov Eax, [Esi].MIB_IPADDRROW.dwAddr
		Mov [Edx].ADAPTER_DATA.dwAddress, Eax
		Mov Eax, [Esi].MIB_IPADDRROW.dwMask
		Mov [Edx].ADAPTER_DATA.dwMask, Eax
		Add Edi, 4
		Invoke SendMessage, hWndCombo, CB_ADDSTRING, 0, Addr MibIfRow.bDescr
	.EndIf
	Add Esi, SizeOf MIB_IPADDRROW
	Pop Ecx
	Dec Ecx
	Jnz L2
	Invoke SelectAdapter, (-1)
	Mov Eax, NO_ERROR
L4:	Ret
InitInterfaces EndP

OpenNetworkConnections Proc Private hWnd:HWND
	.If lPlatForm >= ecWinNT
		Invoke ShellExecute, hWnd, NULL, TextStr("CONTROL.EXE"), TextStr(" ncpa.cpl"), NULL, SW_SHOWNORMAL
	.Else
		Invoke ShellExecute, hWnd, NULL, TextStr("CONTROL.EXE"), TextStr(" Netcpl.cpl"), NULL, SW_SHOWNORMAL
	.EndIf
	Ret
OpenNetworkConnections EndP

ReadIfTable Proc Private Uses Ebx bCheckNet:BOOL
	Local bReturn:BOOL

	Mov bReturn, FALSE
	Mov Eax, dwCurrentIndex
	Cmp Eax, (-1)
	Jne @F
	Xor Eax, Eax
@@:	Shl Eax, 2
	Add Eax, Offset dwIfTableIndex
	Mov Ebx, [Eax]
	Or Ebx, Ebx
	Jnz @F
	Mov dwCurrentIndex, (-1)
L1:	Invoke SelectAdapter, (-1)
	Mov Eax, hIconDisconn
	Jmp L4
@@:	Cmp [Ebx].ADAPTER_DATA.dwType, MIB_IF_TYPE_LOOPBACK
	Je L1
	Mov Eax, [Ebx].ADAPTER_DATA.dwIndex
	Mov MibIfRow.dwIndex, Eax
	Invoke SelectAdapter, MibIfRow.dwSpeed
	Cmp Eax, NO_ERROR
	Jne @F
	Mov Edx, MIB_IF_OPER_STATUS_NON_OPERATIONAL
	.If lPlatForm > ecWinNT
		Mov Edx, MIB_IF_OPER_STATUS_CONNECTING
	.EndIf
	.If MibIfRow.dwOperStatus > Edx
		Mov bReturn, TRUE
	.EndIf
@@:	Mov Eax, MibIfRow.dwInOctets
	Mov [Ebx].ADAPTER_DATA.dwBytesIn, Eax
	Mov Eax, MibIfRow.dwOutOctets
	Mov [Ebx].ADAPTER_DATA.dwBytesOut, Eax
	Cmp bCheckNet, FALSE
	Je @F
	.If bReturn
		Cmp dwNetState, STATUS_DISCONN
		Jne @F
		Mov dwNetState, STATUS_NONE
		Mov Eax, hIconNone
	.Else
		Cmp dwNetState, STATUS_DISCONN
		Je @F
		Mov dwNetState, STATUS_DISCONN
		Mov Eax, hIconDisconn
	.EndIf
L4:	Cmp Eax, IconData.hIcon
	Je @F
	Invoke SetIcons, Eax
@@:	Mov Eax, bReturn
	Ret
ReadIfTable EndP

ReadTcpTableEx Proc Private Uses Edi Esi
	Local dwSize:DWord

	Invoke GetCurrentProcess
	Mov Edi, Eax
	Invoke SetPrivileges, Edi, TRUE

	Xor Esi, Esi
	Mov Eax, lpGetExtendedTcpTable
	Or Eax, Eax
	Je L4
	Mov dwSize, SizeOf MIB_TCPROW_OWNER_PID
	Invoke GlobalAlloc, GPTR, dwSize
	Mov Esi, Eax

	Lea Edx, dwSize
	Push 0
	Push TCP_TABLE_OWNER_PID_ALL
	Push AF_INET
	Push TRUE
	Push Edx
	Push Esi
	Call lpGetExtendedTcpTable ;Invoke GetExtendedTcpTable, Esi, Addr dwSize, TRUE, AF_INET, TCP_TABLE_OWNER_PID_ALL, 0
	Cmp Eax, NO_ERROR
	Je L2
	Cmp Eax, ERROR_INSUFFICIENT_BUFFER
	Jne L4
	Invoke GlobalFree, Esi
	Invoke GlobalAlloc, GPTR, dwSize
	Mov Esi, Eax
L2:	Lea Edx, dwSize
	Push 0
	Push TCP_TABLE_OWNER_PID_ALL
	Push AF_INET
	Push TRUE
	Push Edx
	Push Esi
	Call lpGetExtendedTcpTable ;Invoke GetExtendedTcpTable, Esi, Addr dwSize, TRUE, AF_INET, TCP_TABLE_OWNER_PID_ALL, 0
	Cmp Eax, NO_ERROR
	Je L8
L4:	Or Esi, Esi
	Jz @F
	Invoke GlobalFree, Esi
@@:	Mov lpGetExtendedTcpTable, NULL
	Mov dwSize, SizeOf MIB_TCPROW
	Invoke GlobalAlloc, GPTR, dwSize
	Mov Esi, Eax
	Invoke GetTcpTable, Esi, Addr dwSize, FALSE
	Cmp Eax, NO_ERROR
	Je L6
	Cmp Eax, ERROR_INSUFFICIENT_BUFFER
	Je @F
	Invoke GlobalFree, Esi
	Xor Eax, Eax
	Jmp L10
@@:	Invoke GlobalFree, Esi
	Invoke GlobalAlloc, GPTR, dwSize
	Mov Esi, Eax
L6:	Invoke GetTcpTable, Esi, Addr dwSize, FALSE
	Cmp Eax, NO_ERROR
	Je L8
	Invoke GlobalFree, Esi
	Xor Eax, Eax
	Jmp L10
L8:	Mov Eax, Esi

L10:
	Push Eax
	Invoke SetPrivileges, Edi, FALSE
	Pop Eax
	Ret
ReadTcpTableEx EndP

ReadUdpTableEx Proc Private Uses Edi Esi
	Local dwSize:DWord

	Invoke GetCurrentProcess
	Mov Edi, Eax
	Invoke SetPrivileges, Edi, TRUE

	Xor Esi, Esi
	Mov Eax, lpGetExtendedUdpTable
	Or Eax, Eax
	Je L4
	Mov dwSize, SizeOf MIB_UDPROW_OWNER_PID
	Invoke GlobalAlloc, GPTR, dwSize
	Mov Esi, Eax

	Lea Edx, dwSize
	Push 0
	Push UDP_TABLE_OWNER_PID
	Push AF_INET
	Push TRUE
	Push Edx
	Push Esi
	Call lpGetExtendedUdpTable
	Cmp Eax, NO_ERROR
	Je L2
	Cmp Eax, ERROR_INSUFFICIENT_BUFFER
	Jne L4
	Invoke GlobalFree, Esi
	Invoke GlobalAlloc, GPTR, dwSize
	Mov Esi, Eax
L2:	Lea Edx, dwSize
	Push 0
	Push UDP_TABLE_OWNER_PID
	Push AF_INET
	Push TRUE
	Push Edx
	Push Esi
	Call lpGetExtendedUdpTable
	Cmp Eax, NO_ERROR
	Je L8
L4:	Or Esi, Esi
	Jz @F
	Invoke GlobalFree, Esi
@@:	Mov lpGetExtendedUdpTable, NULL
	Mov dwSize, SizeOf MIB_UDPROW
	Invoke GlobalAlloc, GPTR, dwSize
	Mov Esi, Eax
	Invoke GetUdpTable, Esi, Addr dwSize, FALSE
	Cmp Eax, NO_ERROR
	Je L6
	Cmp Eax, ERROR_INSUFFICIENT_BUFFER
	Je @F
	Invoke GlobalFree, Esi
	Xor Eax, Eax
	Jmp L10
@@:	Invoke GlobalFree, Esi
	Invoke GlobalAlloc, GPTR, dwSize
	Mov Esi, Eax
L6:	Invoke GetUdpTable, Esi, Addr dwSize, FALSE
	Cmp Eax, NO_ERROR
	Je L8
	Invoke GlobalFree, Esi
	Xor Eax, Eax
	Jmp L10
L8:	Mov Eax, Esi

L10:
	Push Eax
	Invoke SetPrivileges, Edi, FALSE
	Pop Eax
	Ret
ReadUdpTableEx EndP

RefreshTcpOpenPorts Proc Private Uses Ebx Edi Esi hWnd:HWND
	Local rc:RECT, lvi:LVITEM

	Cmp bRefreshingTcp, FALSE
	Je @F
	Ret
@@:	Mov bRefreshingTcp, TRUE
	Invoke SetWaitCursor, hWnd
	Invoke GetWindowItem, hWnd, IDC_NETMON_GRPLISTVIEW
	Mov Edi, Eax
	Invoke SendMessage, hWndLvTcp, LVM_GETTOPINDEX, 0, 0
	Push Eax
	Invoke SendMessage, hWndLvTcp, LVM_GETNEXTITEM, (-1), LVNI_SELECTED
	Cmp Eax, (-1)
	Jne @F
	Xor Eax, Eax
@@:	Mov lvi.iItem, Eax
	Invoke SendMessage, hWndLvTcp, LVM_GETITEMCOUNT, 0, 0
	Mov Ebx, Eax
	Invoke SendMessage, Edi, WM_SETREDRAW, FALSE, 0
	Invoke GetTcpOpenPorts
	Invoke SendMessage, hWndLvTcp, LVM_GETITEMCOUNT, 0, 0
	Mov Esi, Eax
	Cmp Eax, lvi.iItem
	Jg @F
	Dec Eax
	Mov lvi.iItem, Eax
@@:	Mov lvi.imask, LVIF_STATE
	Mov lvi.iSubItem, 0
	Mov lvi.state, (LVIS_FOCUSED Or LVIS_SELECTED)
	Mov lvi.stateMask, (LVIS_FOCUSED Or LVIS_SELECTED)
	Invoke SendMessage, hWndLvTcp, LVM_SETITEM, 0, Addr lvi
	Mov rc.left, LVIR_BOUNDS
	Invoke SendMessage, hWndLvTcp, LVM_GETITEMRECT, 0, Addr rc
	Mov Eax, rc.top
	Sub rc.bottom, Eax
	Xor Edx, Edx
	Pop Eax
	Mul rc.bottom
	Invoke SendMessage, hWndLvTcp, LVM_SCROLL, 0, Eax
	Invoke SetFocus, hWndLvTcp
	Invoke SetDefaultCursor
	Invoke SendMessage, Edi, WM_SETREDRAW, TRUE, 0
	.If Ebx == Esi
		Invoke InvalidateRect, hWndLvTcp, NULL, FALSE
	.Else
		Invoke RedrawWindow, Edi, NULL, NULL, (RDW_ERASE Or RDW_INVALIDATE Or RDW_UPDATENOW Or RDW_ALLCHILDREN)
	.EndIf
	Mov bRefreshingTcp, FALSE
	Ret
RefreshTcpOpenPorts EndP

RefreshUdpOpenPorts Proc Private Uses Ebx Edi Esi hWnd:HWND
	Local rc:RECT, lvi:LVITEM

	Cmp bRefreshingUdp, FALSE
	Je @F
	Ret
@@:	Mov bRefreshingUdp, TRUE
	Invoke SetWaitCursor, hWnd
	Invoke GetWindowItem, hWnd, IDC_NETMON_GRPLISTVIEW
	Mov Edi, Eax
	Invoke SendMessage, hWndLvUdp, LVM_GETTOPINDEX, 0, 0
	Push Eax
	Invoke SendMessage, hWndLvUdp, LVM_GETNEXTITEM, (-1), LVNI_SELECTED
	Cmp Eax, (-1)
	Jne @F
	Xor Eax, Eax
@@:	Mov lvi.iItem, Eax
	Invoke SendMessage, hWndLvTcp, LVM_GETITEMCOUNT, 0, 0
	Mov Ebx, Eax
	Invoke SendMessage, Edi, WM_SETREDRAW, FALSE, 0
	Invoke GetUdpOpenPorts
	Invoke SendMessage, hWndLvUdp, LVM_GETITEMCOUNT, 0, 0
	Mov Esi, Eax
	Cmp Eax, lvi.iItem
	Jg @F
	Dec Eax
	Mov lvi.iItem, Eax
@@:	Mov lvi.imask, LVIF_STATE
	Mov lvi.iSubItem, 0
	Mov lvi.state, (LVIS_FOCUSED Or LVIS_SELECTED)
	Mov lvi.stateMask, (LVIS_FOCUSED Or LVIS_SELECTED)
	Invoke SendMessage, hWndLvUdp, LVM_SETITEM, 0, Addr lvi
	Mov rc.left, LVIR_BOUNDS
	Invoke SendMessage, hWndLvUdp, LVM_GETITEMRECT, 0, Addr rc
	Mov Eax, rc.top
	Sub rc.bottom, Eax
	Xor Edx, Edx
	Pop Eax
	Mul rc.bottom
	Invoke SendMessage, hWndLvUdp, LVM_SCROLL, 0, Eax
	Invoke SetFocus, hWndLvUdp
	Invoke SetDefaultCursor
	Invoke SendMessage, Edi, WM_SETREDRAW, TRUE, 0
	.If Ebx == Esi
		Invoke InvalidateRect, hWndLvUdp, NULL, FALSE
	.Else
		Invoke RedrawWindow, Edi, NULL, NULL, (RDW_ERASE Or RDW_INVALIDATE Or RDW_UPDATENOW Or RDW_ALLCHILDREN)
	.EndIf
	Mov bRefreshingUdp, FALSE
	Ret
RefreshUdpOpenPorts EndP

RemoteIPThread Proc Private Uses Ebx Edi Esi lpParameter:LPVOID
	Local hOpen:HANDLE, hFile:HANDLE, hLabel:HANDLE
	Local dwBytesRead:SDWord, sBuffer[128]:Byte

	Invoke SetWaitCursor, App.Main
	Invoke GetWindowItem, App.Main, IDC_NETMON_STCREALIP
	Mov hLabel, Eax
	Invoke LoadAppString, IDS_CONNECTING, Addr szBuffer, 64
	Invoke SetText, hLabel, Addr szBuffer
	Invoke InternetOpen, TextAddr("IE"), INTERNET_OPEN_TYPE_PRECONFIG, NULL, NULL, 0
	Or Eax, Eax
	Jz @F
	Mov hOpen, Eax

	Invoke InternetOpenUrl, hOpen, TextAddr("http://checkip.dyndns.org"), 0, 0,INTERNET_FLAG_RELOAD, 0
	.If Eax == 0
		Invoke InternetCloseHandle, hOpen
		Xor Eax, Eax
		Jmp @F
	.EndIf
	Mov hFile, Eax
	Mov dwBytesRead, 0
	Lea Esi, sBuffer
	Invoke RtlZeroMemory, Esi, SizeOf sBuffer
	Invoke InternetReadFile, hFile, Esi, (SizeOf sBuffer - 2), Addr dwBytesRead
	Invoke InternetCloseHandle, hFile
	Invoke InternetCloseHandle, hOpen
	.If (dwBytesRead > 0) && (dwBytesRead < SizeOf sBuffer)
		Invoke FindString, Esi, TextStr("</body>"), 0
		.If Eax != (-1)
			Add Eax, Esi
			Mov Word Ptr [Eax], 0
			Invoke FindCharRev, Esi, VK_SPACE
			.If Eax != (-1)
				Inc Eax
				Add Esi, Eax
			.EndIf
		.EndIf
		Invoke SetText, hLabel, Esi
		Mov Eax, TRUE
	.EndIf
@@:	.If Eax == 0
		Invoke SetText, hLabel, TextStr("?")
	.EndIf
	Mov bRealIPAddress, TRUE
	Invoke SetDefaultCursor
	Ret
RemoteIPThread EndP

SaveMonitorPosition Proc Private Uses Ebx Edi Esi hWnd:HWND
	Local wp:WINDOWPLACEMENT

	Mov wp.iLength, SizeOf WINDOWPLACEMENT
	Invoke GetWindowPlacement, hWnd, Addr wp
	Lea Ebx, rcLarge
	Lea Edi, szLeft
	Lea Esi, szTop
	Cmp bSmallSize, FALSE
	Je @F
	Lea Ebx, rcSmall
	Lea Edi, szSmallLeft
	Lea Esi, szSmallTop
@@:	Mov Eax, wp.rcNormalPosition.left
	Mov [Ebx].RECT.left, Eax
	Invoke wsprintf, Addr szBuffer, Addr szFormat, Eax
	Invoke SetRegistryValueA, HKEY_CURRENT_USER, Addr szRegistryKey, Edi, Addr szBuffer
	Mov Eax, wp.rcNormalPosition.top
	Mov [Ebx].RECT.top, Eax
	Invoke wsprintf, Addr szBuffer, Addr szFormat, Eax
	Invoke SetRegistryValueA, HKEY_CURRENT_USER, Addr szRegistryKey, Esi, Addr szBuffer
	Ret
SaveMonitorPosition EndP

SelectAdapter Proc Private Uses Ebx dwNetSpeed:DWord
	Cmp dwNetSpeed, (-1)
	Jne L2
	Invoke SendMessage, hWndCombo, CB_SETCURSEL, dwCurrentIndex, 0
	Cmp Eax, CB_ERR
	Jne @F
	Mov dwCurrentIndex, (-1)
	Invoke lstrcpy, Addr IconData.szTip, App.Header
	Jmp L4
@@:	Mov Eax, dwCurrentIndex
	Shl Eax, 2
	Add Eax, Offset dwIfTableIndex
	Mov Eax, [Eax]		;Get adapter data address
	Or Eax, Eax
	Jz L2
	Mov Eax, [Eax].ADAPTER_DATA.dwIndex
	Mov MibIfRow.dwIndex, Eax
L2:	Invoke GetIfEntry, Addr MibIfRow
	Push Eax
	Mov Eax, dwNetSpeed
	.If Eax != MibIfRow.dwSpeed
		Mov Ebx, IDS_KBITS
		Mov Ecx, 1000
		Mov Edx, 100
		Cmp MibIfRow.dwSpeed, 999999
		Jbe @F
		Mov Ebx, IDS_MBITS
		Mov Ecx, 1000000
		Mov Edx, 100000
		Cmp MibIfRow.dwSpeed, 999999999
		Jbe @F
		Mov Ebx, IDS_GBITS
		Mov Ecx, 1000000000
		Mov Edx, 100000000
@@:		Invoke GetSpeedString, MibIfRow.dwSpeed, Ecx, Edx
		Invoke lstrlen, Addr szBuffer
		Add Eax, Offset szBuffer
		Mov Byte Ptr [Eax], VK_SPACE
		Inc Eax
		Invoke LoadAppString, Ebx, Eax, 12
		Invoke SetControlText, IDC_NETMON_STCNETSPEED, Addr szBuffer
		Invoke LoadAppString, IDS_SPEED, Addr IconData.szTip, 64
		Add Eax, Offset IconData.szTip
		Mov Byte Ptr [Eax], ' '
		Mov Byte Ptr [Eax + 1], ' '
		Add Eax, 2
		Invoke lstrcpy, Eax, Addr szBuffer
	.EndIf
	Pop Eax
L4:	Ret
SelectAdapter EndP

SetCaption Proc Private Uses Esi lCountDown:DWord
	Lea Esi, szBuffer
	Invoke lstrcpy, Esi, App.Header
	.If bCountDownActive
		Invoke lstrlen, Esi
		Add Esi, Eax
		Mov Byte Ptr [Esi], ' '
		Mov Byte Ptr [Esi + 1], '('
		Add Esi, 2
		Invoke String, lCountDown, Esi, ecDecimal
		Add Esi, Eax
		Mov Byte Ptr [Esi], 's'
		Mov Byte Ptr [Esi + 1], 0
		Invoke lstrcat, Esi, TextStrA(" / ", 41)
		Add Esi, 4
		Xor Edx, Edx
		Mov Eax, dwMinBytes
		Mov Ecx, 1024
		IDiv Ecx
		Invoke String, Eax, Esi, ecDecimal
		Invoke lstrcat, Esi, TextStrA("KB", 41)
	.EndIf
	Invoke SetWindowText, [App.Main], Addr szBuffer
	Ret
SetCaption EndP

SetControlText Proc Private ulControl:ULONG, lpszText:LPSTR
	Invoke GetWindowItem, IconData.hwnd, ulControl
	Invoke SendMessage, Eax, WM_SETTEXT, 0, lpszText
	Ret
SetControlText EndP

SetMenuText Proc Private Uses Esi hMenu:HMENU, ulMenuID:ULONG, ulStringID:ULONG, byPosition:BOOL
	Local mii:MENUITEMINFO

	Lea Esi, szBuffer
	Mov Word Ptr [Esi], 0
	Mov mii.cbSize, SizeOf MENUITEMINFO
	Mov mii.fType, MFT_STRING
	Mov mii.fMask, MIIM_TYPE
	Mov mii.dwTypeData, Esi
	Invoke LoadAppString, ulStringID, Esi, 128
	Invoke SetMenuItemInfo, hMenu, ulMenuID, byPosition, Addr mii
	.If byPosition
		Mov Eax, MF_BYPOSITION
	.Else
		Mov Eax, MF_BYCOMMAND
	.EndIf
	Or Eax, MF_ENABLED
	Invoke EnableMenuItem, hMenu, ulMenuID, Eax
	Ret
SetMenuText EndP

SetIPAddressString Proc Private Uses Ebx dwAdapterAddress:DWord
	Mov Ebx, dwAdapterAddress
	.If (Ebx <= SDWord Ptr Ebx)
		Mov Eax, dwCurrentIndex
		Cmp Eax, (-1)
		Je L2
		Shl Eax, 2
		Add Eax, Offset dwIfTableIndex
		Mov Ebx, [Eax]		;Get adapter data address
	.EndIf
	.If ([Ebx].ADAPTER_DATA.dwAddress == 0)
		Invoke InitInterfaces
		Mov Eax, dwCurrentIndex
		Cmp Eax, (-1)
		Je L2
		Shl Eax, 2
		Add Eax, Offset dwIfTableIndex
		Mov Ebx, [Eax]		;Get adapter data address
	.EndIf
	Invoke GetWindowItem, IconData.hwnd, IDC_NETMON_STCIP
	Push Eax
	Invoke IPToStr, [Ebx].ADAPTER_DATA.dwAddress, Addr szBuffer
	Pop Edx
	Invoke SendMessage, Edx, WM_SETTEXT, 0, Addr szBuffer
	Invoke GetWindowItem, IconData.hwnd, IDC_NETMON_STCSUBMASK
	Push Eax
	Invoke IPToStr, [Ebx].ADAPTER_DATA.dwMask, Addr szBuffer
	Pop Edx
	Invoke SendMessage, Edx, WM_SETTEXT, 0, Addr szBuffer
L2:	Ret
SetIPAddressString EndP

SetKBValues Proc
	.If KBValue == 1024
		Mov dwRS_ONE_KB, 1024
		Mov dwRS_ONE_KB_DIV_10, 102
		Mov dwRS_ONE_MB, 1048576
		Mov dwRS_ONE_MB_DIV_10, 104857
	.Else
		Mov dwRS_ONE_KB, 1000
		Mov dwRS_ONE_KB_DIV_10, 100
		Mov dwRS_ONE_MB, 1000000
		Mov dwRS_ONE_MB_DIV_10, 100000
	.EndIf
	Ret
SetKBValues EndP

SetMonitorSize Proc Private Uses Edi Esi hWnd:HWND
	Local rc:RECT

	.If bSmallSize
		Invoke CopyRect, Addr rc, Addr rcSmall
		Mov Edi, SW_HIDE
		Mov Esi, lSmallTop
	.Else
		Invoke CopyRect, Addr rc, Addr rcLarge
		Mov Edi, SW_SHOWNORMAL
		Mov Esi, lLargeTop
	.EndIf
	Invoke SetWindowPos, hWnd, NULL, rc.left, rc.top, rc.right, rc.bottom, (SWP_NOZORDER Or SWP_FRAMECHANGED)
	Invoke GetWindowItem, hWnd, IDC_NETMON_TABSTRIP1
	Invoke ShowWindow, Eax, Edi
	Invoke GetWindowItem, hWnd, IDC_NETMON_GROUP1
	Invoke ShowWindow, Eax, Edi
	Invoke GetWindowItem, hWnd, IDC_NETMON_GROUP2
	Invoke ShowWindow, Eax, Edi
	Invoke GetWindowItem, hWnd, IDC_NETMON_GROUP3
	Invoke SetWindowPos, Eax, NULL, lLeft, Esi, 0, 0, (SWP_NOZORDER Or SWP_NOSIZE)
	Invoke wsprintf, Addr szBuffer, Addr szFormat, bSmallSize
	Invoke SetRegistryValueA, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szSmallSize, Addr szBuffer
	Ret
SetMonitorSize EndP

SetPrivileges Proc Private hProcess:HANDLE, bEnable:BOOL
	Local hToken:HANDLE, tp:TOKEN_PRIVILEGES

	Mov Eax, (-1)
	.If lPlatForm >= ecWinNT
		Invoke OpenProcessToken, hProcess, (TOKEN_ADJUST_PRIVILEGES Or TOKEN_QUERY), Addr hToken
		Invoke LookupPrivilegeValue, NULL, TextStr("SeDebugPrivilege"), Addr tp.Privileges.Luid
		Mov tp.PrivilegeCount, 1
		Xor Eax, Eax
		.If bEnable
			Mov Eax, SE_PRIVILEGE_ENABLED
		.EndIf
		Mov tp.Privileges.Attributes, Eax
		Invoke AdjustTokenPrivileges, hToken, FALSE, Addr tp, SizeOf TOKEN_PRIVILEGES, NULL, NULL
		Invoke GetLastError
		Push Eax
		Invoke CloseHandle, hToken
		Pop Eax
	.EndIf
	Ret
SetPrivileges EndP

SetTabItemText Proc Private Uses Esi hWndTabStrip:HWND, lItemIndex:LONG, lStringID:ULONG
	Local tcItem:TCITEM

	Lea Esi, szBuffer
	Mov tcItem.pszText, Esi
	Mov tcItem._mask, TCIF_TEXT
	Mov tcItem.cchTextMax, 64
	Invoke LoadAppString, lStringID, Esi, 64
	Invoke SendMessage, hWndTabStrip, TCM_SETITEM, lItemIndex, Addr tcItem
	Ret
SetTabItemText EndP

SetThousand Proc Private Uses Ebx Edi Esi
	Lea Esi, szBuffer
	Add Esi, 64
	Mov Edi, Esi
	Mov Ebx, Esi
	Sub Edi, 2
	Mov Byte Ptr [Edi], 0
	Dec Edi
	Invoke lstrlen, Esi
	Add Esi, Eax
	Mov Ecx, 3
L2:	Dec Esi
	Mov Al, [Esi]
	Mov [Edi], Al
	Dec Edi
	Dec Ecx
	Jnz @F
	Cmp Esi, Ebx
	Je @F
	Mov Al, [sThousand]
	Mov [Edi], Al
	Dec Edi
	Mov Ecx, 3
@@:	Cmp Esi, Ebx
	Jne L2
	Inc Edi
	Mov Eax, Edi
	Ret
SetThousand EndP

ShutDownPC Proc Private
	Local handle:HANDLE
	Local tp:TOKEN_PRIVILEGES

	Invoke GetPlatform, NULL
	.If (Eax > ecWinME)
		Invoke GetCurrentProcess
		Mov Edx, Eax
		Invoke OpenProcessToken, Edx, TOKEN_ADJUST_PRIVILEGES Or TOKEN_QUERY, Addr handle
		Invoke LookupPrivilegeValue, NULL, TextStr("SeShutdownPrivilege"), Addr tp.Privileges.Luid
		Mov tp.PrivilegeCount, 1
		Mov tp.Privileges.Attributes, SE_PRIVILEGE_ENABLED
		Invoke AdjustTokenPrivileges, handle, FALSE, Addr tp, SizeOf tp, NULL, NULL
	.EndIf
	Invoke SendMessage, App.Main, WM_CLOSE, 0, 0
	Invoke ExitWindowsEx, (EWX_SHUTDOWN Or EWX_POWEROFF Or EWX_FORCE), 0
	Ret
ShutDownPC EndP

StoreAppStrings Proc Private Uses Ebx Edi Esi lpszBuf:LPSTR
	Invoke GlobalAlloc, GPTR, MAX_PATH
	Mov Ebx, Eax
	Mov Esi, lpszBuf
L2:	Mov Edi, Ebx
	Xor Ecx, Ecx
	Xor Edx, Edx
	Cmp Byte Ptr [Esi + Ecx], 0
	Jne @F
	Invoke GlobalFree, Ebx
	Ret
@@:	Mov Al, Byte Ptr [Esi + Ecx]
	Or Al, Al
	Jz @F
	.If Al == '\'
		Inc Ecx
		Mov Al, Byte Ptr [Esi + Ecx]
		.If Al == '0'
			Sub Al, 48
		.ElseIf Al == 't'
			Mov Al, 9
		.ElseIf Al == 'n'
			Mov Al, 10
		.ElseIf Al == 'r'
			Mov Al, 13
		.ElseIf Al == '\'
			Mov Al, '\'
		.ElseIf Al == "'"
			Mov Al, "'"
		.ElseIf Al == '"'
			Mov Al, '"'
		.ElseIf Al == '?'
			Mov Al, '?'
		.ElseIf Al == 'b'
			Mov Al, 8
		.ElseIf Al == 'a'
			Mov Al, 7
		.ElseIf Al == 'f'
			Mov Al, 12
		.ElseIf Al == 'v'
			Mov Al, 11
		.Else
			Dec Ecx
		.EndIf
	.ElseIf Al == 13 || Al == 10 || Al == 0
		Jmp @F
	.EndIf
	Mov Byte Ptr [Edi + Edx], Al
	Inc Ecx
	Inc Edx
	Jmp @B
@@:	Mov Byte Ptr [Edi + Edx], 0
	Add Esi, Ecx
	Invoke FindChar, Ebx, '='
	.If Eax != (-1)
		Inc Eax
		Add Eax, Ebx
	.EndIf
	Invoke SendMessage, hWndLBStr, LB_ADDSTRING, 0, Eax
	.While Byte Ptr [Esi] < 32
		.If Byte Ptr [Esi]
			.If Byte Ptr [Esi] < 32
				Inc Esi
			.EndIf
		.Else
			.Break
		.EndIf
	.EndW
	Jmp L2
StoreAppStrings EndP

UpdateBytes Proc Private Uses Ebx Edi Esi bForce:BOOL
	Mov Eax, dwCurrentIndex
	Cmp Eax, (-1)
	Je L4
	Shl Eax, 2
	Add Eax, Offset dwIfTableIndex
	Mov Ebx, [Eax]
	Lea Esi, szBuffer
	Add Esi, 64
	Cmp bForce, FALSE
	Jne @F
	Mov Eax, [Ebx].ADAPTER_DATA.dwBytesIn
	Cmp Eax, [Ebx].ADAPTER_DATA.dwLastBytesIn
	Je L2
@@:	Invoke wsprintf, Esi, Addr szFormat, [Ebx].ADAPTER_DATA.dwBytesIn
	Invoke SetThousand
	Invoke SetControlText, IDC_NETMON_STCRECEIVED, Eax
L2:	Cmp bForce, FALSE
	Jne @F
	Mov Eax, [Ebx].ADAPTER_DATA.dwBytesOut
	Cmp Eax, [Ebx].ADAPTER_DATA.dwLastBytesOut
	Je L4
@@:	Invoke wsprintf, Esi, Addr szFormat, [Ebx].ADAPTER_DATA.dwBytesOut
	Invoke SetThousand
	Invoke SetControlText, IDC_NETMON_STCSENT, Eax
L4:	Ret
UpdateBytes EndP

UpdateLights Proc Uses Ebx Edi Esi bUpdateSpeed:BOOL, bForce:BOOL
	.If dwNetState != STATUS_DISCONN
		Mov Eax, dwCurrentIndex
		Cmp Eax, (-1)
		Jne @F
		Ret
@@:		Shl Eax, 2
		Add Eax, Offset dwIfTableIndex
		Mov Ebx, [Eax]
		Invoke ReadIfTable, FALSE
		Mov Edi, [Ebx].ADAPTER_DATA.dwBytesIn
		Mov Esi, [Ebx].ADAPTER_DATA.dwBytesOut
		.If Edi != [Ebx].ADAPTER_DATA.dwLastBytesIn && Esi != [Ebx].ADAPTER_DATA.dwLastBytesOut
			Sub Edi, [Ebx].ADAPTER_DATA.dwLastBytesIn
			Sub Esi, [Ebx].ADAPTER_DATA.dwLastBytesOut
			.If dwNetState != (STATUS_RECEIVE Or STATUS_SEND) && ([Ebx].ADAPTER_DATA.dwBytesIn || [Ebx].ADAPTER_DATA.dwBytesOut)
				Mov dwNetState, (STATUS_RECEIVE Or STATUS_SEND)
				Mov bUpdateSpeed, TRUE
				Mov Eax, hIconBoth
@@:				Cmp Eax, IconData.hIcon
				Je L4
				Invoke SetIcons, Eax
			.EndIf
		.ElseIf Edi != [Ebx].ADAPTER_DATA.dwLastBytesIn
			Sub Edi, [Ebx].ADAPTER_DATA.dwLastBytesIn
			Xor Esi, Esi
			.If dwNetState != STATUS_RECEIVE
				Mov dwNetState, STATUS_RECEIVE
				Mov bUpdateSpeed, TRUE
				Mov Eax, hIconReceive
				Jmp @B
			.EndIf
		.ElseIf Esi != [Ebx].ADAPTER_DATA.dwLastBytesOut
			Xor Edi, Edi
			Sub Esi, [Ebx].ADAPTER_DATA.dwLastBytesOut
			.If dwNetState != STATUS_SEND
				Mov dwNetState, STATUS_SEND
				Mov bUpdateSpeed, TRUE
				Mov Eax, hIconSend
				Jmp @B
			.EndIf
		.Else
			Xor Edi, Edi
			Xor Esi, Esi
			.If dwNetState != STATUS_NONE
				Mov dwNetState, STATUS_NONE
				Mov bUpdateSpeed, TRUE
				Mov Eax, hIconNone
				Jmp @B
			.EndIf
		.EndIf
L4:		Invoke UpdateBytes, FALSE
		.If bUpdateSpeed
			Invoke UpdateSpeed, Edi, IDC_NETMON_STCSPEEDIN, Addr [Ebx].ADAPTER_DATA.dwLastSpeedIn, bForce
			Invoke UpdateSpeed, Esi, IDC_NETMON_STCSPEEDOUT, Addr [Ebx].ADAPTER_DATA.dwLastSpeedOut, bForce
		.EndIf
	.EndIf
@@:	Ret
UpdateLights EndP

UpdateSpeed Proc Private Uses Ebx Edi Esi dwBytesSecond:DWord, ulControl1:ULONG, lpdwLastSpeed:DWord, bForce:BOOL
	.If SDWord Ptr SpeedScale > 0
		Invoke MulDiv, dwBytesSecond, 1000000, SpeedScale
		Mov dwBytesSecond, Eax
	.EndIf

	Invoke ConvertToScale, dwBytesSecond
	Mov dwBytesSecond, Eax
	Mov Edx, lpdwLastSpeed
	Cmp bForce, FALSE
	Jne @F
	Cmp Eax, DWord Ptr [Edx]
	Jne @F
	Ret
@@:	Mov [Edx], Eax
	Mov Edi, dwRS_ONE_KB
	Mov Esi, dwRS_ONE_KB_DIV_10
	Mov Ebx, IDS_KBYTES
	Cmp bBits, FALSE
	Je @F
	Mov Ebx, IDS_KBITS
@@:	Cmp Eax, dwRS_ONE_MB
	Jl L2
	Mov Ebx, IDS_MBYTES
	Cmp bBits, FALSE
	Je @F
	Mov Ebx, IDS_MBITS
@@:	Mov Edi, dwRS_ONE_MB
	Mov Esi, dwRS_ONE_MB_DIV_10
L2:	Invoke GetSpeedString, Eax, Edi, Esi
	Lea Esi, szBuffer
	Invoke lstrlen, Addr szBuffer
	Add Esi, Eax
	Mov Byte Ptr [Esi], VK_SPACE
	Inc Esi
	Invoke LoadAppString, Ebx, Esi, 20
	Invoke SetControlText, ulControl1, Addr szBuffer
	Mov Edi, lMeterDownIndex
	Cmp ulControl1, IDC_NETMON_STCSPEEDIN
	Je @F
	Mov Edi, lMeterUpIndex
@@:	Invoke SetMeterValue, Edi, dwBytesSecond
	Ret
UpdateSpeed EndP
